Auxiliary material for Paper 2010JA015326

A computationally compact representation of Magnetic-Apex and Quasi-Dipole coordinates with smooth base vectors

J. T. Emmert and D. P. Drob
Space Science Division, U.S. Naval Research Laboratory, Washington, D.C., USA

A. D. Richmond
High Altitude Observatory, National Center for Atmospheric Research, Boulder, Colorado, USA


Emmert, J. T., A. D. Richmond, and D. P. Drob (2010), A computationally compact representation of magnetic Apex and Quasi-Dipole coordinates with smooth base vectors, J. Geophys. Res., 115, A08322, doi:10.1029/2010JA015326.

Introduction

Auxiliary material for this article contains Fortran code for converting from geodetic to Quasi-Dipole (QD) and
Modified Apex coordinates, for computing base vectors in these coordinates, for converting
from QD to geodetic coordinates, and for generating expansion coefficients for these conversions,
as described in the paper. Updated versions of this code will be made available on the 
CEDAR Data System at http://cedarweb.hao.ucar.edu/.

1. 2010ja015326-txts01.txt 
checkapexsh.f90: Fortran-90 test driver and usage example for the QD 
coordinate conversion code package.

2. 2010ja015326-txts02.txt 
apexsh.f90: Fortran-90 code for converting among coordinate systems
and computing base vectors. This file contains all the routines necessary to do the conversions.
The last three files are only needed to generate a file containing  the expansion coefficients.

3. 2010ja015326-txt03.txt 
makeapexsh.f90: Fortran-90 code for generating the expansion
coefficients used by apexsh.f90. Must be compiled together with apexsh.f90, apex.f, and magfld.f.

4. 2010ja015326-txts04.txt 
apex.f: Fortran-77 code for computing the apex height of magnetic
field lines.

5. 2010ja015326-txts05.txt 
magfld.f: Fortran-77 code for evaluating IGRF.

Auxiliary material for Paper 2010JA015326

A computationally compact representation of Magnetic-Apex and Quasi-Dipole
coordinates with smooth base vectors

J. T. Emmert and D. P. Drob
Space Science Division, U.S. Naval Research Laboratory, Washington, D.C., USA

A. D. Richmond
High Altitude Observatory, National Center for Atmospheric Research, Boulder,
Colorado, USA


Emmert, J. T., A. D. Richmond, and D. P. Drob (2010), A computationally compact
representation of magnetic Apex and Quasi-Dipole coordinates with smooth base
vectors, J. Geophys. Res., 115, A08322, doi:10.1029/2010JA015326.

Introduction
------------

Auxiliary material for this article contains Fortran code for converting from
geodetic to Quasi-Dipole (QD) and Modified Apex coordinates, for computing base
vectors in these coordinates, for converting from QD to geodetic coordinates,
and for generating expansion coefficients for these conversions, as described
in the paper. Updated versions of this code will be made available on the  CEDAR
Data System at http://cedarweb.hao.ucar.edu/.

1. 2010ja015326-txts01.txt 
checkapexsh.f90: Fortran-90 test driver and usage example for the QD 
coordinate conversion code package.

2. 2010ja015326-txts02.txt 
apexsh.f90: Fortran-90 code for converting among coordinate systems
and computing base vectors. This file contains all the routines necessary to do
the conversions. The last three files are only needed to generate a file
containing  the expansion coefficients.

3. 2010ja015326-txt03.txt 
makeapexsh.f90: Fortran-90 code for generating the expansion
coefficients used by apexsh.f90. Must be compiled together with apexsh.f90,
apex.f, and magfld.f.

4. 2010ja015326-txts04.txt 
apex.f: Fortran-77 code for computing the apex height of magnetic
field lines.

5. 2010ja015326-txts05.txt 
magfld.f: Fortran-77 code for evaluating IGRF.

##############################################

DEV NOTES:
----------

The above text is copy-pasted from the auxiliary materials for the Emmert et al.
(2010) paper.

In February 2021, the magfld.f source was modified so that it could read IGRF
coefficients from the text file instead of from hard-coded constants.
Specifically the COFRM subroutine was modified. This also required modifying
APEX subroutine in apex.f, the makeapxsh subroutine in makeapexsh.f90, and the
checkapexsh program in checkapexsh.f90.


MAINTENANCE NOTE:
-----------------

After updating the IGRF coefficients file, we need to rebuild the apexsh.dat
file. This is done by:

1) Adding the next 5 year epoch to "epochgrid" and updating the "nepochgrid"
   variable in checkapexsh.f90. For example, if epochgrid has up to the year
   2020 and the newest IGRF coefficients are good up to 2025, we should add
   2025 to epochgrid and then increment nepochgrid by 1.
2) checkapexsh.f90 also expects the IGRF coefficient file to be in the same
   directory with the name "igrf14coeffs.txt", so you may also need to update
   the "igrffilein" variable as well.
3) Building the "apextest" binary using the "make" command.
4) Copying the resulting "apexsh.dat" file to the apexpy/src/apexpy directory.

If the fortran code is updated, the .pyf file will also need to be recreated.
This can be done by:

$ f2py -m fortranapex apexsh.f90 igrf.f90 apex.f90 magfld.f90 makeapexsh.f90 -h fortranapex.pyf

Be sure you remove the existing `fortranapex.pyf` file before performing this
step.

!******************************************************************************
!
!  File Name: apexsh.f90
!  Authors: John Emmert, Art Richmond
!  Date: 11/13/2009
!  Version: 1.0
!  Description: Converts geodetic coordinates to and from Quasi-Dipole and
!               Modified Apex Coordinates.
!
!  References: Richmond, A. D., Ionospheric Electrodynamics Using Magnetic Apex
!                Coordinates, J. Geomag. Geoelectr., 47, 191-212, 1995.
!              Emmert, J. T., A. D. Richmond, and D. P. Drob, A computationally
!                compact representation of Magnetic-Apex and Quasi-Dipole
!                coordinates with smooth base vectors, J. Geophys. Res., 115,
!                Axxxxx, doi:10.1029/2010JA015326, 2010.
!
!*******************************************************************************
!
!  LOADAPXSH
!  Loads spherical harmonic coefficients (created by MAKEAPXSH) for coordinate
!  conversions. Must be run before calling the conversion routines.
!
!  CALL LOADAPXSH (DATAFILE, EPOCH)
!
!  INPUT ARGUMENTS
!    DATAFILE  Name of data file, generated by MAKEAPXSH, containing the
!              conversion coefficients
!    EPOCH     Date for which coordinates are desired (decimal years, yyyy.y,
!              single precision)
!
!*******************************************************************************
!
!  APXG2Q
!  Converts geodetic to Quasi-Dipole coordinates
!  Must call LOADAPXSH first. All arguments are single precision, except for
!  VECFLAG, which is a 4-byte integers.
!
!  CALL APXG2Q (GLAT, GLON, ALT, VECFLAG, QLAT, QLON, F1, F2, F)
!
!  INPUT ARGUMENTS
!    GLAT     Geodetic latitude (degrees)
!    GLON     Geodetic longitude (degrees)
!    ALT      Altitude (km)
!    VECFLAG  Set this flag to zero to calculate coordinates only, without base
!             vectors. The base vector output arguments will be filled with
!             -9999.
!
!  OUTPUT ARGUMENTS
!    QLAT      Quasi-Dipole latitude (degrees)
!    QLON      Quasi-Dipole longitude (degrees)
!    F1,F2     Quasi-Dipole coordinates base vectors described in
!              Richmond (1995). The two elements of each vector contain the
!              geodetic east and north components. F1 points in the QD
!              east direction, and F2 points in the QD north direction.
!    F         F = |F1 x F2|, as described in Richmond (1995)
!
!*******************************************************************************
!
!  APXG2ALL
!  Converts geodetic to Quasi-Dipole and Modified Apex coordinates
!  Must call LOADAPXSH first. All arguments are single precision, except for
!  MAFLAG and VECFLAG, which are 4-byte integers.
!
!  CALL APXG2ALL (GLAT, GLON, ALT, HR, VECFLAG, &
!                 QLAT, QLON, MLAT, MLON, &
!                 F1,F2,F, D1,D2,D3,D, E1,E2,E3)
!
!  INPUT ARGUMENTS
!    GLAT     Geodetic latitude (degrees)
!    GLON     Geodetic longitude (degrees)
!    ALT      Altitude (km)
!    HR       Modified Apex coordinates reference altitude (km)
!    VECFLAG  Set this flag to zero to calculate coordinates only, without base
!             vectors. The base vector output arguments will be filled with
!             -9999.
!
!  OUTPUT ARGUMENTS
!    QLAT      Quasi-Dipole latitude (degrees)
!    QLON      Quasi-Dipole longitude (degrees)
!    MLAT      Modified Apex latitude (degrees)
!    MLON      Modified Apex longitude (degrees)
!    F1,F2     Quasi-Dipole coordinates base vectors described in
!              Richmond (1995). The two elements of each vector contain the
!              geodetic east and north components. F1 points in the QD east
!              direction, and F2 points in the QD north direction.
!    F         F = |F1 x F2|, as described in Richmond (1995)
!    D1,D2,D3  Modified Apex coordinates base vectors described in
!              Richmond (1995). The three elements of each vector contain the
!              geodetic east, north, and up components. D1 and D2 are generally
!              perpendicular to the magnetic field and point in the magnetic
!              east and downward/equatorward directions. D3 points along the
!              magnetic field.
!    D         D = |D1 x D2|, as described in Richmond (1995)
!    E1,E2,E3  Modified Apex coordinates base vectors described in
!              Richmond (1995). The three elements of each vector contain the
!              geodetic east, north, and up components. E1 and E2 are generally
!              perpendicular to the magnetic field and point in the magnetic
!              east and downward/equatorward directions. E3 points along the
!              magnetic field.
!
!*******************************************************************************
!
!  APXQ2G
!  Converts Quasi-Dipole to geodetic coordinates
!  All arguments are single precision.
!
!  CALL APXQ2G (QLAT, QLON, ALT, PREC, GLAT, GLON, ERROR)
!
!  INPUT ARGUMENTS
!    QLAT   Quasi-Dipole latitude (degrees)
!    QLON   Quasi-Dipole longitude (degrees)
!    ALT    Altitude (km)
!    PREC   Precision of output (degrees). A negative value of this argument
!           produces a low-precision calculation of geodetic lat and lon based
!           only on their spherical harmonic representation. A positive value
!           causes the routine to iterate until feeding the output glat and
!           glon coordinates into APXG2Q reproduces the input qlat and qlon to
!           within the specified precision.
!
!  OUTPUT ARGUMENTS
!    GLAT   Geodetic latitude (degrees)
!    GLON   Geodetic longitude (degrees)
!    ERROR  The angular difference (degrees) between the input qlat and qlon
!           coordinates and the qlat and qlon produced by feeding the output
!           glat and glon into APG2ALL.
!
!*******************************************************************************

module apxshmodule

    implicit none

    integer(4)               :: nterm, nmax, mmax, lmax, nepoch, ntermsh
    integer(4)               :: vecflag

    real(8), allocatable     :: coeff0(:,:,:)
    real(8), allocatable     :: qcoeff0(:,:), gcoeff0(:,:)
    real(8), allocatable     :: xqcoeff(:), yqcoeff(:), zqcoeff(:)
    real(8), allocatable     :: dxqdrhocoeff(:), dyqdrhocoeff(:), dzqdrhocoeff(:)
    real(8), allocatable     :: xgcoeff(:), ygcoeff(:), zgcoeff(:)
    real(8), allocatable     :: sh(:), shgradtheta(:), shgradphi(:)
    real(8), allocatable     :: polynomq(:), dpolynomq(:), polynomg(:)
    real(8), allocatable     :: pbar(:,:), vbar(:,:), wbar(:,:)
    real(4), allocatable     :: epochgrid(:)

    real(8)                  :: h, Reph, rho
    real(8)                  :: xq, yq, zq
    real(8)                  :: qlat, qlon
    real(8)                  :: sinqlat, cosqlat, cosqlon, sinqlon
    real(8)                  :: xqgrad(1:3), yqgrad(1:3), zqgrad(1:3)
    real(8)                  :: qlatgrad(1:3), qlongrad(1:3)

    real(8), parameter       :: pi=3.14159265358979323846D0
    real(8), parameter       :: dtor=pi/180D0, pid2=pi/2D0, twopi=2D0*pi
    real(8), parameter       :: Req=6378.1370D0, eps=1.D0/298.257223563D0
    real(8), parameter       :: Re=Req*(1-eps/3D0), ecc2=eps*(2-eps)
    real(4), parameter       :: missing=-9999E0

!   Req = Equatorial radius of Earth in km (WGS84 value)
!   eps = flatness of ellipsoidal Earth (WGS84 value)
!   Re = Mean radius of Earth in km
!   ecc2 = squared eccentricity of ellipsoidal Earth

    character(1000)          :: datafile
    real(4)                  :: epoch
    real(4)                  :: altlastq, altlastg
    logical                  :: loadflag = .true.

end module apxshmodule

!*******************************************************************************

subroutine loadapxsh(datafilenew,epochnew)

    use apxshmodule

    implicit none

    character(1000)             :: datafilenew, datafilelast=''
    real(4)                     :: epochnew, epochlast=-999.0
    real(8)                     :: we0, we1
    integer(4)                  :: iepoch0, iepoch1, iterm, icoord

    !CHECK FILE, GET DIMENSIONS, AND ALLOCATE ARRAYS
    if ((datafilenew .ne. datafilelast) .or. (loadflag)) then
      datafile = datafilenew
      open(unit=23,file=trim(datafile),status='old',form='unformatted')
      read(23) nepoch, nmax, mmax, lmax, nterm
      call allocatearrays
      read(23) epochgrid, coeff0
      close(23)
    endif
    
    !LOAD COEFFICIENTS AND INTEPOLATE TO SELECTED EPOCH
    if ((epochnew .ne. epochlast) .or. (datafilenew .ne. datafilelast) .or.(loadflag)) then
      epoch = epochnew
      if (epoch .lt. epochgrid(0)) epoch=epochgrid(0)
      if (epoch .gt. epochgrid(nepoch-1)) epoch=epochgrid(nepoch-1)
      if (nepoch .eq. 1) then
        iepoch0 = 0
        iepoch1 = 0
        we0 = 1D0
        we1 = 0D0
      else
        iepoch0 = nepoch - 1
        do while ((epochgrid(iepoch0) .ge. epoch) .and. (iepoch0 .gt. 0))
          iepoch0 = iepoch0 - 1
        enddo
        iepoch1 = iepoch0 + 1
        we0 = dble( (epochgrid(iepoch1) - epoch) / (epochgrid(iepoch1)-epochgrid(iepoch0)) )
        we1 = 1D0 - we0
      endif
      do icoord = 0, 2
      do iterm = 0, nterm-1
        qcoeff0(iterm,icoord)= we0*coeff0(iterm,iepoch0,icoord)  +we1*coeff0(iterm,iepoch1,icoord)
        gcoeff0(iterm,icoord)= we0*coeff0(iterm,iepoch0,icoord+3)+we1*coeff0(iterm,iepoch1,icoord+3)
      enddo
      enddo
      altlastq = -999.0
      altlastg = -999.0
    endif

    !UPDATE LOAD VARIABLES
    loadflag = .false.
    datafilelast = datafilenew
    epochlast = epochnew

    return

end subroutine loadapxsh

!*******************************************************************************

subroutine allocatearrays

    use apxshmodule

    implicit none

    external alfbasisinit

    !RESET ARRAYS
    if (allocated(epochgrid)) deallocate(epochgrid)
    if (allocated(coeff0)) deallocate(coeff0)
    if (allocated(gcoeff0)) deallocate(gcoeff0)
    if (allocated(qcoeff0)) deallocate(qcoeff0)
    if (allocated(xqcoeff)) deallocate(xqcoeff)
    if (allocated(yqcoeff)) deallocate(yqcoeff)
    if (allocated(zqcoeff)) deallocate(zqcoeff)
    if (allocated(dxqdrhocoeff)) deallocate(dxqdrhocoeff)
    if (allocated(dyqdrhocoeff)) deallocate(dyqdrhocoeff)
    if (allocated(dzqdrhocoeff)) deallocate(dzqdrhocoeff)
    if (allocated(xgcoeff)) deallocate(xgcoeff)
    if (allocated(ygcoeff)) deallocate(ygcoeff)
    if (allocated(zgcoeff)) deallocate(zgcoeff)
    if (allocated(sh)) deallocate(sh)
    if (allocated(shgradphi)) deallocate(shgradphi)
    if (allocated(shgradtheta)) deallocate(shgradtheta)
    if (allocated(polynomq)) deallocate(polynomq)
    if (allocated(dpolynomq)) deallocate(dpolynomq)
    if (allocated(polynomg)) deallocate(polynomg)
    if (allocated(pbar)) deallocate(pbar)
    if (allocated(vbar)) deallocate(vbar)
    if (allocated(wbar)) deallocate(wbar)

    !ALLOCATE ARRAYS
    ntermsh = mmax*(2*nmax - mmax + 1) + nmax + 1
    allocate(    epochgrid(0:nepoch-1) )
    allocate(       coeff0(0:nterm-1, 0:nepoch-1, 0:5) )
    allocate(      qcoeff0(0:nterm-1, 0:2) )
    allocate(      gcoeff0(0:nterm-1, 0:2) )
    allocate(      xqcoeff(0:ntermsh-1) )
    allocate(      yqcoeff(0:ntermsh-1) )
    allocate(      zqcoeff(0:ntermsh-1) )
    allocate( dxqdrhocoeff(0:ntermsh-1) )
    allocate( dyqdrhocoeff(0:ntermsh-1) )
    allocate( dzqdrhocoeff(0:ntermsh-1) )
    allocate(      xgcoeff(0:ntermsh-1) )
    allocate(      ygcoeff(0:ntermsh-1) )
    allocate(      zgcoeff(0:ntermsh-1) )
    allocate(           sh(0:ntermsh-1) )
    allocate(  shgradtheta(0:ntermsh-1) )
    allocate(    shgradphi(0:ntermsh-1) )
    allocate(     polynomq(0:lmax) )
    allocate(    dpolynomq(0:lmax) )
    allocate(     polynomg(0:lmax) )
    allocate(         pbar(0:nmax, 0:mmax) )
    allocate(         vbar(0:nmax, 0:mmax) )
    allocate(         wbar(0:nmax, 0:mmax) )
    polynomq(0) = 1D0
    dpolynomq(0) = 0D0
    polynomg(0) = 1D0
    pbar = 0
    vbar = 0
    wbar = 0
    call alfbasisinit(nmax,mmax)

    return

end subroutine allocatearrays

!***************************************************************************************************

subroutine apxg2q(glat,glon,alt,vecflagin,qlatout,qlonout,f1,f2,f)

    use apxshmodule

    implicit none

    real(4), intent(in)         :: glat, glon, alt
    integer(4), intent(in)      :: vecflagin
    real(4), intent(out)        :: qlatout, qlonout
    real(4), intent(out)        :: f1(1:2), f2(1:2), f

    integer(4)               :: i, l, iterm, itermsh
    real(8)                  :: theta, phi
    real(8)                  :: costheta, Jtemp, J, r

    !INITIALIZE OUTPUT ARGUMENTS    
    qlat = missing
    qlon = missing
    f1 = missing
    f2 = missing
    f = missing

    !CHECK THAT COEFFICIENTS ARE LOADED
    if (loadflag) then
      print *, 'No coefficients loaded. Call LOADAPXSH first.'
      return
    endif

    !COPY INPUT FLAG
    vecflag = vecflagin     
    
    !COMPUTE SPATIAL COEFFICIENTS AND THEIR VERTICAL GRADIENTS FOR THE SPECIFIED HEIGHT
    if (alt .ne. altlastq) then
      h = dble(alt)
      Reph = Re + h
      rho = Re / Reph
      do l = 1, lmax
        polynomq(l) = polynomq(l-1)*rho
        dpolynomq(l) = dble(l)*polynomq(l-1)
      enddo
      xqcoeff = 0
      yqcoeff = 0
      zqcoeff = 0
      dxqdrhocoeff = 0
      dyqdrhocoeff = 0
      dzqdrhocoeff = 0
      do itermsh = 0, ntermsh-1
        do l = 0, lmax
          iterm = l*ntermsh + itermsh
          xqcoeff(itermsh) = xqcoeff(itermsh) + qcoeff0(iterm,0)*polynomq(l)
          yqcoeff(itermsh) = yqcoeff(itermsh) + qcoeff0(iterm,1)*polynomq(l)
          zqcoeff(itermsh) = zqcoeff(itermsh) + qcoeff0(iterm,2)*polynomq(l)
          dxqdrhocoeff(itermsh) = dxqdrhocoeff(itermsh) + qcoeff0(iterm,0)*dpolynomq(l)
          dyqdrhocoeff(itermsh) = dyqdrhocoeff(itermsh) + qcoeff0(iterm,1)*dpolynomq(l)
          dzqdrhocoeff(itermsh) = dzqdrhocoeff(itermsh) + qcoeff0(iterm,2)*dpolynomq(l)
        enddo
      enddo
      altlastq = alt
    endif

    !COMPUTE SPHERICAL HARMONICS
    theta = (90D0 - dble(glat)) * dtor
    phi = glon * dtor
    call shcalc(theta,phi)

    !COMPUTE AND RETURN QUASI-DIPOLE COORDINATES
    xq = dot_product(sh, xqcoeff)
    yq = dot_product(sh, yqcoeff)
    zq = dot_product(sh, zqcoeff)
    qlon = datan2(yq,xq)
    cosqlon = dcos(qlon)
    sinqlon = dsin(qlon)
    qlat = datan2(zq,dsqrt(xq*xq + yq*yq))
    cosqlat = dcos(qlat)
    sinqlat = dsin(qlat)
    qlonout = sngl(qlon / dtor)
    qlatout = sngl(qlat / dtor)

    !BASE VECTOR CALCULATIONS
    if (vecflag .ne. 0) then    

      !COMPUTE HORIZONTAL GRADIENT KERNELS OF QUASI-DIPOLE CARTESIAN COORDINATES
      xqgrad(1) = dot_product(shgradphi, xqcoeff)
      yqgrad(1) = dot_product(shgradphi, yqcoeff)
      zqgrad(1) = dot_product(shgradphi, zqcoeff)
      xqgrad(2) = -dot_product(shgradtheta, xqcoeff)
      yqgrad(2) = -dot_product(shgradtheta, yqcoeff)
      zqgrad(2) = -dot_product(shgradtheta, zqcoeff)

      !COMPUTE ADJUSTMENTS TO GRADIENTS FOR ELLIPSOIDAL EARTH
      costheta = dcos(theta)
      Jtemp = 1D0 - ecc2*costheta*costheta
      r = Req / dsqrt(Jtemp)
      J = (h + (1 - ecc2) * r / Jtemp) / Reph
      r = (h + r) / Reph

      !COMPUTE HORIZONTAL GEODETIC GRADIENTS OF QD LATITUDE AND LONGITUDE
      qlatgrad(1) = (-( cosqlon*xqgrad(1) + sinqlon*yqgrad(1))*sinqlat + cosqlat*zqgrad(1)) / r
      qlatgrad(2) = (-( cosqlon*xqgrad(2) + sinqlon*yqgrad(2))*sinqlat + cosqlat*zqgrad(2)) / J
      qlongrad(1) =   (-sinqlon*xqgrad(1) + cosqlon*yqgrad(1)) / r
      qlongrad(2) =   (-sinqlon*xqgrad(2) + cosqlon*yqgrad(2)) / J

      !RETURN QUASI-DIPOLE BASE VECTORS
      f1(1) = sngl( qlatgrad(2))
      f1(2) = sngl(-qlatgrad(1))
      f2(1) = sngl(-qlongrad(2))
      f2(2) = sngl(qlongrad(1))
      f = f1(1)*f2(2) - f1(2)*f2(1)

    endif

    return

end subroutine apxg2q

!******************************************************************************

subroutine apxg2all(glat,glon,alt,hr,vecflagin, &
                    qlatout,qlonout, mlat,mlon, f1,f2,f, d1,d2,d3,d, e1,e2,e3)

    use apxshmodule

    implicit none

    real(4), intent(in)         :: glat, glon, alt, hr
    integer(4), intent(in)      :: vecflagin
    real(4), intent(out)        :: qlatout, qlonout, mlat, mlon
    real(4), intent(out)        :: f1(1:2), f2(1:2), f
    real(4), intent(out)        :: d1(1:3), d2(1:3), d3(1:3), d
    real(4), intent(out)        :: e1(1:3), e2(1:3), e3(1:3)

    integer(4)               :: i
    real(8)                  :: cosmlat, Rrat, denom

    if (loadflag) then
      print *, 'No coordinates loaded. Call LOADAPXSH first.'
      stop
    endif

    !INITIALIZE OUTPUT ARGUMENTS    
    mlat = missing
    mlon = missing
    d1 = missing
    d2 = missing
    d3 = missing
    d = missing
    e1 = missing
    e2 = missing
    e3 = missing

    !COMPUTE QUASI-DIPOLE COORDINATES
    call apxg2q(glat,glon,alt,vecflagin,qlatout,qlonout,f1,f2,f)
    if (qlatout .eq. missing) return

    !COMPUTE AND RETURN MODIFIED APEX COORDINATES
    mlon = qlonout
    Rrat = (Re + dble(hr)) / Reph
    cosmlat = cosqlat * dsqrt(Rrat)
    if (cosmlat .le. 1D0) then
      mlat = sngl(dacos(cosmlat) / dtor)
      if (qlat .lt. 0D0) mlat = -mlat
    endif

    !MODIFIED APEX BASE VECTOR CALCULATIONS
    if (vecflag .ne. 0) then    

      !COMPUTE VERTICAL GRADIENTS OF QUASI-DIPOLE COORDINATES
      xqgrad(3) = dot_product(sh, dxqdrhocoeff)
      yqgrad(3) = dot_product(sh, dyqdrhocoeff)
      zqgrad(3) = dot_product(sh, dzqdrhocoeff)
      qlatgrad(3) = rho*((cosqlon*xqgrad(3) + sinqlon*yqgrad(3))*sinqlat - cosqlat*zqgrad(3))
      qlongrad(3) = rho* (sinqlon*xqgrad(3) - cosqlon*yqgrad(3))

      !COMPUTE MA BASE VECTORS
      denom = 4D0/Rrat - 3D0*cosqlat*cosqlat
      if (denom .le. 0) return
      denom = dsqrt(denom)
      do i = 1, 3
        d1(i) = sngl(Rrat*dsqrt(Rrat)*qlongrad(i))
        d2(i) = sngl(-2D0*Rrat*sinqlat*qlatgrad(i)/denom)
      enddo
      d2(3) = d2(3) - sngl(Rrat*cosqlat/denom)
      e3(1) = d1(2)*d2(3) - d1(3)*d2(2)
      e3(2) = d1(3)*d2(1) - d1(1)*d2(3)
      e3(3) = d1(1)*d2(2) - d1(2)*d2(1)
      d = e3(1)**2 + e3(2)**2 + e3(3)**2
      do i=1,3
        d3(i) = e3(i)/d
      enddo
      d = sqrt(d)
      e1(1) = d2(2)*d3(3) - d2(3)*d3(2)
      e1(2) = d2(3)*d3(1) - d2(1)*d3(3)
      e1(3) = d2(1)*d3(2) - d2(2)*d3(1)
      e2(1) = d3(2)*d1(3) - d3(3)*d1(2)
      e2(2) = d3(3)*d1(1) - d3(1)*d1(3)
      e2(3) = d3(1)*d1(2) - d3(2)*d1(1)

    endif

    return

end subroutine apxg2all

!*******************************************************************************

subroutine apxq2g(qlat0,qlon0,alt,prec,glatout,glonout,error)

    use apxshmodule

    implicit none

    real(4), intent(in)         :: qlat0, qlon0, alt, prec
    real(4), intent(out)        :: glatout, glonout, error

    integer(4)               :: l, iterm, itermsh, vecflagin, niter
    real(4)                  :: qlatout, qlonout, errorlast
    real(4)                  :: mlon, f1(1:2), f2(1:2), f
    real(8)                  :: theta, phi
    real(8)                  :: sinqlon0, cosqlon0, sinqlat0, cosqlat0, cotqlat0, zfact
    real(8)                  :: glat, glon
    real(8)                  :: xg, yg, zg, cosglat
    real(8)                  :: xggrad(1:2), yggrad(1:2), zggrad(1:2)
    real(8)                  :: delqlon, delqlat, delxq, delyq, denom
    real(8)                  :: coserror

    if (loadflag) then
      print *, 'No coordinates loaded. Call LOADAPXSH first.'
      stop
    endif

    !COMPUTE SPATIAL COEFFICIENTS FOR THE SPECIFIED HEIGHT
    if (alt .ne. altlastg) then
      rho = Re / (Re + dble(alt))
      do l = 1, lmax
        polynomg(l) = polynomg(l-1)*rho
      enddo
      xgcoeff = 0
      ygcoeff = 0
      zgcoeff = 0
      do itermsh = 0, ntermsh-1
        do l = 0, lmax
          iterm = l*ntermsh + itermsh
          xgcoeff(itermsh) = xgcoeff(itermsh) + gcoeff0(iterm,0)*polynomg(l)
          ygcoeff(itermsh) = ygcoeff(itermsh) + gcoeff0(iterm,1)*polynomg(l)
          zgcoeff(itermsh) = zgcoeff(itermsh) + gcoeff0(iterm,2)*polynomg(l)
        enddo
      enddo
      altlastg = alt
    endif

    !COMPUTE SPHERICAL HARMONICS
    phi = dble(qlon0) * dtor
    theta = (90D0 - dble(qlat0)) * dtor
    vecflag = 1
    call shcalc(theta,phi)

    !COMPUTE INITIAL GEODETIC COORDINATES
    xg = dot_product(sh, xgcoeff)
    yg = dot_product(sh, ygcoeff)
    zg = dot_product(sh, zgcoeff)
    glon = datan2(yg,xg)
    glat = datan2(zg,dsqrt(xg*xg + yg*yg))
    glatout = sngl(glat / dtor)
    glonout = sngl(glon / dtor)
    error = missing

    !COMPUTE REFINED GEODETIC COORDINATES
    if (prec .ge. 0) then
      xggrad(1) = dot_product(shgradphi, xgcoeff)
      yggrad(1) = dot_product(shgradphi, ygcoeff)
      zggrad(1) = dot_product(shgradphi, zgcoeff)
      xggrad(2) = -dot_product(shgradtheta, xgcoeff)
      yggrad(2) = -dot_product(shgradtheta, ygcoeff)
      zggrad(2) = -dot_product(shgradtheta, zgcoeff)
      vecflagin = 1
      call apxg2q(glatout,glonout,alt,vecflagin,qlatout,qlonout,f1,f2,f)
      cosqlat0 = dsin(theta)
      sinqlat0 = dcos(theta)
      coserror = sinqlat0*sinqlat+cosqlat0*cosqlat*cos(phi-qlon)
      if (coserror .gt. 1) coserror = 1D0
      error = sngl(acos(coserror) / dtor)
      niter = 0
      errorlast = 9999.0
      !OUTSIDE OF QD POLES
      if ((abs(qlat0) .lt. 88.0) .and. (error .gt. prec)) then
        vecflagin = 0
        do while ((error .gt. prec) .and. (niter .lt. 10) .and. (error .lt. 1.3*errorlast))
          delqlon = phi - qlon
          if (abs(delqlon) .gt. pi) delqlon = -sign(twopi-abs(delqlon),delqlon)
          delqlon = cosqlat0 * delqlon
          delqlat = pid2 - theta - qlat
          xg = xg + xggrad(1)*delqlon + xggrad(2)*delqlat
          yg = yg + yggrad(1)*delqlon + yggrad(2)*delqlat
          zg = zg + zggrad(1)*delqlon + zggrad(2)*delqlat
          glonout = sngl(datan2(yg,xg) / dtor)
          glatout = sngl(datan2(zg,dsqrt(xg*xg + yg*yg)) / dtor)
          call apxg2q(glatout,glonout,alt,vecflagin,qlatout,qlonout,f1,f2,f)
          coserror = sinqlat0*sinqlat+cosqlat0*cosqlat*cos(phi-qlon)
          if (coserror .gt. 1) coserror = 1D0
          errorlast = error
          error = sngl(acos(coserror) / dtor)
          niter = niter + 1
        enddo
      !NEAR QD POLES
      else if (error .gt. prec) then
        cosqlon0 = dcos(phi)
        sinqlon0 = dsin(phi)
        cotqlat0 = cosqlat0 / sinqlat0
        cosglat = dcos(glat)
        vecflagin = 1
        do while ((error .gt. prec) .and. (niter .lt. 10) .and. (error .lt. 1.3*errorlast))
          zfact = zq * cotqlat0
          delxq = zfact * cosqlon0 - xq
          delyq = zfact * sinqlon0 - yq
          denom = xqgrad(1)*yqgrad(2) - xqgrad(2)*yqgrad(1)
          glon = glon + (delxq*yqgrad(2) - delyq*xqgrad(2)) / denom / cosglat
          glat = glat + (delyq*xqgrad(1) - delxq*yqgrad(1)) / denom
          glonout = sngl(glon / dtor)
          glatout = sngl(glat / dtor)
          call apxg2q(glatout,glonout,alt,vecflagin,qlatout,qlonout,f1,f2,f)
          coserror = sinqlat0*sinqlat+cosqlat0*cosqlat*cos(phi-qlon)
          if (coserror .gt. 1) coserror = 1D0
          errorlast = error
          error = sngl(acos(coserror) / dtor)
          niter = niter + 1
        enddo
      endif
    endif

    return

end subroutine apxq2g

!*******************************************************************************

subroutine shcalc(theta,phi)

    use apxshmodule

    implicit none

    real(8), intent(in)      :: theta, phi

    integer(4)               :: n, m, i, i1
    real(8)                  :: mphi, cosmphi, sinmphi

    call alfbasis(nmax,mmax,theta,pbar,vbar,wbar)
    i = 0
    i1 = 0
    do n = 0, nmax
      sh(i) = pbar(n,0)
      shgradtheta(i1) =  vbar(n,0)
      shgradphi(i1) = 0
      i = i + 1
      i1 = i1 + 1
    enddo
    do m = 1, mmax
      mphi = dble(m) * phi
      cosmphi = dcos(mphi)
      sinmphi = dsin(mphi)
      do n = m, nmax
        sh(i)   = pbar(n,m) * cosmphi
        sh(i+1) = pbar(n,m) * sinmphi
        i = i + 2
      enddo
      if (vecflag .ne. 0) then
        do n = m, nmax
          shgradtheta(i1)   =  vbar(n,m) * cosmphi
          shgradtheta(i1+1) =  vbar(n,m) * sinmphi
          shgradphi(i1)     = -wbar(n,m) * sinmphi
          shgradphi(i1+1)   =  wbar(n,m) * cosmphi
          i1 = i1 + 2
        enddo
      endif
    enddo

end subroutine shcalc

!*******************************************************************************

module alfbasismodule

    implicit none

    integer(4)           :: nmax0
    integer(4)           :: mmax0
    real(8), allocatable :: anm(:,:)
    real(8), allocatable :: cm(:)
    real(8), allocatable :: bnm(:,:)
    real(8), allocatable :: dnm(:,:)
    real(8), allocatable :: en(:)
    real(8), allocatable :: marr(:)
    real(8), allocatable :: narr(:)

end module alfbasismodule

!*******************************************************************************

subroutine alfbasisinit(nmax0in,mmax0in)

    use alfbasismodule

    implicit none

    integer(4), intent(in) :: nmax0in, mmax0in
    integer(8)             :: n, m

    nmax0 = nmax0in
    mmax0 = mmax0in
    if (allocated(anm)) deallocate(anm, bnm, cm, dnm, en, marr, narr)
    allocate( anm(0:nmax0, 0:mmax0) )
    allocate( bnm(0:nmax0, 0:mmax0) )
    allocate( cm(0:mmax0) )
    allocate( dnm(0:nmax0, 0:mmax0) )
    allocate( en(0:nmax0) )
    allocate( marr(0:mmax0) )
    allocate( narr(0:nmax0) )

    do n = 1, nmax0
      narr(n) = dble(n)
      en(n)    = dsqrt(dble(n*(n+1)))
      anm(n,0) = dsqrt( dble((2*n-1)*(2*n+1)) ) / narr(n)
      bnm(n,0) = dsqrt( dble((2*n+1)*(n-1)*(n-1)) / dble(2*n-3) ) / narr(n)
    enddo
    do m = 1, mmax0
      marr(m) = dble(m)
      cm(m)    = dsqrt(dble(2*m+1)/dble(2*m))
      do n = m+1, nmax0
        anm(n,m) = dsqrt( dble((2*n-1)*(2*n+1)) / dble((n-m)*(n+m)) )
        bnm(n,m) = dsqrt( dble((2*n+1)*(n+m-1)*(n-m-1)) / dble((n-m)*(n+m)*(2*n-3)) )
        dnm(n,m) = dsqrt( dble((n-m)*(n+m)*(2*n+1)) / dble(2*n-1) )
      enddo
    enddo

    return

end subroutine alfbasisinit

!******************************************************************************

subroutine alfbasis(nmax,mmax,theta,P,V,W)

    use alfbasismodule

    implicit none

    integer(4), intent(in)  :: nmax, mmax
    real(8), intent(in)     :: theta
    real(8), intent(out)    :: P(0:nmax,0:mmax)
    real(8), intent(out)    :: V(0:nmax,0:mmax)
    real(8), intent(out)    :: W(0:nmax,0:mmax)

    integer(4)              :: n, m
    real(8)                 :: x, y
    real(8), parameter      :: p00=0.70710678118654746D0

    P(0,0) = p00
    x = dcos(theta)
    y = dsin(theta)
    do m = 1, mmax
      W(m,m) = cm(m) * P(m-1,m-1)
      P(m,m) = y * W(m,m)
      do n = m+1, nmax
        W(n,m) = anm(n,m) * x * W(n-1,m) - bnm(n,m) * W(n-2,m)
        P(n,m) = y * W(n,m)
        V(n,m) = narr(n) * x * W(n,m) - dnm(n,m) * W(n-1,m)
        W(n-2,m) = marr(m) * W(n-2,m)
      enddo
      W(nmax-1,m) = marr(m) * W(nmax-1,m)
      W(nmax,m) = marr(m) * W(nmax,m)
      V(m,m) = x * W(m,m)
    enddo
    P(1,0) = anm(1,0) * x * P(0,0)
    V(1,0) = -en(1) * P(1,1)
    do n = 2, nmax
      P(n,0) = anm(n,0) * x * P(n-1,0) - bnm(n,0) * P(n-2,0)
      V(n,0) = -en(n) * P(n,1)
    enddo

    return

end subroutine alfbasis

!*******************************************************************************

C  FILE NAME: apex.f

      SUBROUTINE APEX (DATE,DLAT,DLON,ALT,
     +                 A,ALAT,ALON,BMAG,XMAG,YMAG,ZMAG,V)
C          Calculate apex radius, latitude, longitude; and magnetic field and
C          scalar magnetic potential.
C
C          INPUTS:
C            DATE = Year and fraction (1990.0 = 1990 January 1, 0 UT)
C            DLAT = Geodetic latitude in degrees
C            DLON = Geodetic longitude in degrees
C            ALT = Altitude in km
C
C          RETURNS:
C            A    = (Apex height + REQ)/REQ, where REQ = equatorial Earth radius.
C                   A is analogous to the L value in invariant coordinates.
C            ALAT = Apex latitude in degrees (negative in S. magnetic hemisphere)
C            ALON = Apex longitude (geomagnetic longitude of apex) in degrees
C            BMAG = geomagnetic field magnitude (nT)
C            XMAG = geomagnetic field component (nT): north
C            YMAG = geomagnetic field component (nT): east
C            ZMAG = geomagnetic field component (nT): downward
C            V    = geomagnetic potential (T-m)
C
C          COMMON BLOCKS:
C            COMMON /DIPOLE/ COLAT,ELON,VP,CTP,STP
C
C          DIPOLE has IGRF variables obtained from routines in magfld.f:
C            COLAT = Geocentric colatitude of geomagnetic dipole north pole (deg)
C            ELON  = East longitude of geomagnetic dipole north pole (deg)
C            VP    = Magnitude (T-m) of dipole component of magnetic potential at
C                    geomagnetic pole and geocentric radius of 6371.0088 km
C            CTP   = cosine of COLAT
C            STP   = sine   of COLAT
C
C------------------------------------------------------------------------------
C          HISTORY:
C          Aug 1994: First version completed on the 22nd by A.D. Richmond.
C          May 1999: Revise DS calculation in LINAPX to avoid divide by zero.
C          Apr 2004: - Change definition of earth's equatorial radius (REQ)
C                      from the IAU-1966 spheroid (6378.160 km) to the WGS-1984
C                      spheroid (6378.137 km); see description below.
C                    - Revise comments toward a consistent format so they are
C                      easy to read.
C                    - Replace computed GO TO in ITRACE with IF blocks.
C                    - Refine FNDAPX to insure |Bdown/Btot| < 1.E-6 at apex
C          Nov 2009: Change definition of earth's mean radius (RE) from 6371.2 
C                    to the WGS84 value (6371.0088), by J.T. Emmert, NRL
C
C------------------------------------------------------------------------------
C                Reference Spheroid Change                March 2004
C
C   Apex geomagnetic coordinates are based on the International Reference
C   Geomagnetic Field (IGRF) which involves the earth's shape when converting
C   geographic latitude and altitude to geocentric coordinates.  For this
C   purpose, the earth is assumed to be an ellipsoid which is fatter at the
C   equator than the poles.  The World Geodetic System 1984 spheroid
C   (WGS-1984) is recommended in the recent release of IGRF-9 because it is
C   used to position current satellite magnetic data (EOS Volume 84 Number 46
C   November 18 2003).  This differs from previous IGRF releases which favored
C   the International Astronomical Union 1966 spheroid (IAU-1966) so the Apex
C   program conversion from geographic to geocentric coordinates in subroutine
C   CONVRT of file magfld.f has been revised from the IAU-1966 spheroid to the
C   WGS-1984 spheroid.
C
C   The spheroid used to prepare earlier IGRF releases is not always known but
C   changing spheroids now produces differences at the earth's surface less
C   than 1 nT, significantly less than other error sources: viz., 9 nT RMS
C   error for older measurements reporting 1 nT accuracy, 200 nT in the
C   vicinity of magnetized rocks, or as much as 1000 nT during and after a
C   geomagnetic storm (www.ngdc.noaa.gov/IAGA/vmod/index.html).
C
C   The elliptical shape is characterized in subroutine CONVRT by eccentricity
C   (e) which is related to the the earth's equatorial radius (a) and polar
C   radius (b) by
C
C        e**2  = 1 - (b/a)**2     (1)
C
C   This term is part of an eighth order Lagrange expansion formula (Astron.
C   J.  Vol. 66, p. 15-16, 1961) designed to give eight digit conversion
C   accuracy.  The following table summarizes the relevant spheroids:
C
C        a           b           e**2          Source
C        ----------- -----------  -----------  --------------
C        -           -        0.006722670  Astron J. 1961
C        6378.160 km 6356.775 km  0.006701642  IAU-1966
C        6378.137 km 6356.752 km  0.006694478  WGS-1984
C
C   The previous formulation in CONVRT used the oblateness factor (epsilon),
C   a surrogate for eccentricity, where
C
C        e**2 = 2*epsilon - epsilon**2
C
C   with oblateness revised from the 1961 paper's suggested 1/297 to 1/298.25
C   in accordance with the IAU-1966 spheroid.  Now CONVRT is reformulated to
C   use equation 1 with the WGS-1984 spheroid's major axis (a) and minor axis
C   (b) for which epsilon is approximately 1/298.2528.
C
C   In addition to earth's equatorial radius and polar radius, the reference
C   radius (Re) of 6371.2 km is explicit in the IGRF formula for magnetic
C   potential and implicit in the derived magnetic field coefficients.  The
C   reference radius has not changed in IGRF releases.
C
C------------------------------------------------------------------------------

      PARAMETER (RE = 6371.0088, DTOR = .01745329251994330)
      COMMON /DIPOLE/ COLAT,ELON,VP,CTP,STP

      CALL COFRM (DATE)
      CALL DYPOL (CLATP,POLON,VPOL)
      COLAT = CLATP
      CTP   = COS(CLATP*DTOR)
      STP   = SQRT(1. - CTP*CTP)
      ELON  = POLON
      VP    = VPOL
      CALL LINAPX (DLAT,DLON,ALT, A,ALAT,ALON,XMAG,YMAG,ZMAG,BMAG)
      XMAG = XMAG*1.E5                 ! convert from gauss to nT
      YMAG = YMAG*1.E5
      ZMAG = ZMAG*1.E5
      BMAG = BMAG*1.E5
      CALL GD2CART (DLAT,DLON,ALT,X,Y,Z)
      CALL FELDG (3, X/RE,Y/RE,Z/RE, BX,BY,BZ,V)
      RETURN
      END

      SUBROUTINE LINAPX (GDLAT,GLON,ALT, A,ALAT,ALON,XMAG,YMAG,ZMAG,F)

C          Transform geographic coordinates to Apex coordinates.
C
C          INPUTS:
C            GDLAT = Latitude  (degrees, positive northward)
C            GLON  = Longitude (degrees, positive eastward)
C            ALT   = Height of starting point (km above mean sea level)
C
C          OUTPUTS:
C            A     = (Apex height + REQ)/REQ, where REQ = equatorial Earth radius.
C                    A is analogous to the L value in invariant coordinates.
C            ALAT  = Apex Lat. (deg)
C            ALON  = Apex Lon. (deg)
C            XMAG  = Geomagnetic field component (gauss): north
C            YMAG  = Geomagnetic field component (gauss): east
C            ZMAG  = Geomagnetic field component (gauss): down
C            F     = Geomagnetic field magnitude (gauss)
C
C          Trace the geomagnetic field line from the given location to find the
C          apex of the field line.  Before starting iterations to trace along
C          the field line: (1) Establish a step size (DS, arc length in km)
C          based on the geomagnetic dipole latitude; (2) determine the step
C          direction from the sign of the vertical component of the geomagnetic
C          field; and (3) convert to geocentric cartesian coordinates.  Each
C          iteration increments a step count (NSTP) and calls ITRACE to move
C          along the the field line until reaching the iteration count limit
C          (MAXS) or passing the apex (IAPX=2) and then calling FNDAPX to
C          determine the apex location from the last three step locations
C          (YAPX); however, if reaching the iteration limit, apex coordinates
C          are calculated by DIPAPX which assumes a simplified dipole field.
C
C          COMMON BLOCKS:
C            COMMON /APXIN/   YAPX(3,3)
C            COMMON /DIPOLE/  COLAT,ELON,VP,CTP,STP
C            COMMON /FLDCOMD/ BX, BY, BZ, BB
C            COMMON /ITRA/    NSTP, Y(3), YOLD(3), SGN, DS
C
C          APXIN has step locations determined in ITRACE:
C            YAPX  = Matrix of cartesian coordinates (loaded columnwise) of the
C                    three points about the apex.  Set in subroutine ITRACE.
C                                                                               
C          DIPOLE has IGRF variables obtained from routines in magfld.f:
C            COLAT = Geocentric colatitude of geomagnetic dipole north pole (deg)
C            ELON  = East longitude of geomagnetic dipole north pole (deg)
C            VP    = Magnitude (T-m) of dipole component of magnetic potential at
C                    geomagnetic pole and geocentric radius of 6371.0088 km
C            CTP   = cosine of COLAT
C            STP   = sine   of COLAT
C                                                                               
C          FLDCOMD has geomagnetic field at current trace point:
C            BX    = X component (Gauss)
C            BY    = Y component (Gauss)
C            BZ    = Z component (Gauss)
C            BB    = Magnitude   (Gauss)
C
C          ITRA has field line tracing variables determined in LINAPX:
C            NSTP  = Step count.
C            Y     = Array containing current tracing point cartesian coordinates.
C            YOLD  = Array containing previous tracing point cartesian coordinates.
C            SGN   = Determines direction of trace.
C            DS    = Step size (arc length in km).
C                                                                               
C          REFERENCES:
C            Stassinopoulos E. G. , Mead Gilbert D., X-841-72-17 (1971) GSFC,
C            Greenbelt, Maryland
C                                                                               
C          EXTERNALS:
C            GD2CART = Convert geodetic to geocentric cartesian coordinates (in magfld.f)
C            CONVRT  = Convert geodetic to geocentric cylindrical or geocentric spherical
C                      and back (in magfld.f).
C            FELDG   = Obtain IGRF magnetic field components (in magfld.f).
C            ITRACE  = Follow a geomagnetic field line
C            DIPAPX  = Compute apex coordinates assuming a geomagnetic dipole field
C            FNDAPX  = Compute apex coordinates from the last three traced field line points
C
C------------------------------------------------------------------------------
C          HISTORY:
C          Oct 1973: Initial version completed on the 29th by Wally Clark, NOAA
C                    ERL Lab.
C          Feb 1988: Revised on the 1st by Harsh Anand Passi, NCAR.
C          Aug 1994: Revision by A. D. Richmond, NCAR.
C          Nov 2009: Change definition of earth's mean radius (RE) from 6371.2 
C                    to the WGS84 value (6371.0088), by J.T. Emmert, NRL.

      PARAMETER (MAXS = 200, RTOD = 57.2957795130823,   RE =6371.0088,
     +                       DTOR = .01745329251994330, REQ=6378.137)
      COMMON /FLDCOMD/ BX, BY, BZ, BB
      COMMON /APXIN/   YAPX(3,3)
      COMMON /DIPOLE/  COLAT,ELON,VP,CTP,STP
      COMMON /ITRA/    NSTP, Y(3), YP(3), SGN, DS

C          Set step size based on the geomagnetic dipole latitude of the starting point
      CALL CONVRT (2,GDLAT,ALT,GCLAT,R)
      SINGML = CTP*SIN(GCLAT*DTOR) + STP*COS(GCLAT*DTOR)*
     +                                             COS((GLON-ELON)*DTOR)
C          May 1999: avoid possible divide by zero (when SINGML = 1.): the old version
C          limited DS to its value at 60 deg GM latitude with: DS = .06*R/(1.-SINGML*SINGML) - 370.
C                                                              IF (DS .GT. 1186.) DS = 1186.
      CGML2 = AMAX1 (0.25,1.-SINGML*SINGML)
      DS = .06*R/CGML2 - 370.

C          Initialize YAPX array
      DO 4 J=1,3
      DO 4 I=1,3
    4 YAPX(I,J) = 0.

C          Convert from geodetic to earth centered cartesian coordinates
      CALL GD2CART (GDLAT,GLON,ALT,Y(1),Y(2),Y(3))
      NSTP = 0

C          Get magnetic field components to determine the direction for
C          tracing the field line
      CALL FELDG (1,GDLAT,GLON,ALT,XMAG,YMAG,ZMAG,F)
      SGN = SIGN (1.,-ZMAG)

C          Use cartesian coordinates to get magnetic field components
C          (from which gradients steer the tracing)
   10 CALL FELDG (2, Y(1)/RE,Y(2)/RE,Y(3)/RE, BX,BY,BZ,BB)
      NSTP = NSTP + 1

      IF (NSTP .LT. MAXS) THEN
        CALL ITRACE (IAPX)                              ! trace along field line
        IF (IAPX .EQ. 1) GO TO 10
        CALL FNDAPX (ALT,ZMAG,A,ALAT,ALON)              ! (IAPX=2) => passed max radius; find its coordinates
      ELSE
        RHO = SQRT (Y(1)*Y(1) + Y(2)*Y(2))              ! too many steps; get apex from dipole approximation
        CALL CONVRT (3,XLAT,HT,RHO,Y(3))
        XLON = RTOD*ATAN2 (Y(2),Y(1))
        CALL FELDG (1,XLAT,XLON,HT,BNRTH,BEAST,BDOWN,BABS)
        CALL DIPAPX  (XLAT,XLON,HT,BNRTH,BEAST,BDOWN,A,ALON)
        ALAT = -SGN*RTOD*ACOS (SQRT(1./A))
      ENDIF

      RETURN
      END

      SUBROUTINE ITRACE (IAPX)

C          Follow a geomagnetic field line until passing its apex
C
C          INPUTS:
C            (all are in common blocks)
C          OUTPUTS:
C            IAPX = 2 (when apex passed) or 1 (not)
C                                                                               
C          This uses the 4-point Adams formula after initialization.
C          First 7 iterations advance point by 3 steps.
C                                                                               
C          COMMON BLOCKS:
C            COMMON /APXIN/   YAPX(3,3)
C            COMMON /FLDCOMD/ BX, BY, BZ, BB
C            COMMON /ITRA/    NSTP, Y(3), YOLD(3), SGN, DS
C
C          APXIN has step locations determined in ITRACE:
C            YAPX  = Matrix of cartesian coordinates (loaded columnwise) of the
C                    three points about the apex.  Set in subroutine ITRACE.
C                                                                               
C          FLDCOMD has geomagnetic field at current trace point:
C            BX    = X component (Gauss)
C            BY    = Y component (Gauss)
C            BZ    = Z component (Gauss)
C            BB    = Magnitude   (Gauss)
C                                                                               
C          ITRA has field line tracing variables determined in LINAPX:
C            NSTP  = Step count.
C            Y     = Array containing current tracing point cartesian coordinates.
C            YOLD  = Array containing previous tracing point cartesian coordinates.
C            SGN   = Determines direction of trace.
C            DS    = Step size (arc length in km).
C
C          REFERENCES:
C            Stassinopoulos E. G. , Mead Gilbert D., X-841-72-17 (1971) GSFC,
C            Greenbelt, Maryland
C------------------------------------------------------------------------------
C          HISTORY:
C          Oct 1973: Initial version completed on the 29th by W. Clark, NOAA ERL
C                    Laboratory.
C          Feb 1988: Revised by H. Passi, NCAR.
C          Apr 2004: Replace computed GO TO with IF blocks because some compilers
C                    are threatening to remove this old feature
C

      COMMON /APXIN/   YAPX(3,3)
      COMMON /FLDCOMD/ BX, BY, BZ, BB
      COMMON /ITRA/    NSTP, Y(3), YOLD(3), SGN, DS
      DIMENSION YP(3,4)
      SAVE

C          Statement function
      RDUS(D,E,F) = SQRT (D**2 + E**2 + F**2)

      IAPX = 1

C          Cartesian component magnetic field (partial) derivitives steer the trace
      YP(1,4) = SGN*BX/BB
      YP(2,4) = SGN*BY/BB
      YP(3,4) = SGN*BZ/BB

      IF (NSTP .LE. 7) THEN
        DO 10 I=1,3
        IF (NSTP .EQ. 1) THEN
          D2        = DS/2.
          D6        = DS/6.
          D12       = DS/12.
          D24       = DS/24.
          YP(I,1)   = YP(I,4)
          YOLD(I)   = Y(I)
          YAPX(I,1) = Y(I)
          Y(I)      = YOLD(I) + DS*YP(I,1)

        ELSE IF (NSTP .EQ. 2) THEN
          YP(I,2) = YP(I,4)
          Y(I)    = YOLD(I) + D2*(YP(I,2)+YP(I,1))

        ELSE IF (NSTP .EQ. 3) THEN
          Y(I) = YOLD(I) + D6*(2.*YP(I,4)+YP(I,2)+3.*YP(I,1))

        ELSE IF (NSTP .EQ. 4) THEN
          YP(I,2)   = YP(I,4)
          YAPX(I,2) = Y(I)
          YOLD(I)   = Y(I)
          Y(I)      = YOLD(I) + D2*(3.*YP(I,2)-YP(I,1))

        ELSE IF (NSTP .EQ. 5) THEN
          Y(I) = YOLD(I) + D12*(5.*YP(I,4)+8.*YP(I,2)-YP(I,1))

        ELSE IF (NSTP .EQ. 6) THEN
          YP(I,3)   = YP(I,4)
          YOLD(I)   = Y(I)
          YAPX(I,3) = Y(I)
          Y(I)      = YOLD(I) + D12*(23.*YP(I,3)-16.*YP(I,2)+5.*YP(I,1))

        ELSE IF (NSTP .EQ. 7) THEN
          YAPX(I,1) = YAPX(I, 2)
          YAPX(I,2) = YAPX(I, 3)
          Y(I)      = YOLD(I) + D24*(9.*YP(I,4) + 19.*YP(I,3) -
     +                               5.*YP(I,2) +     YP(I,1))
          YAPX(I,3) = Y(I)
        ENDIF
   10   CONTINUE
        IF (NSTP .EQ. 6 .OR. NSTP .EQ. 7) THEN        ! signal if apex passed
          RC = RDUS (YAPX(1,3), YAPX(2,3), YAPX(3,3))
          RP = RDUS (YAPX(1,2), YAPX(2,2), YAPX(3,2))
          IF (RC .LT. RP) IAPX = 2
        ENDIF

      ELSE                 ! NSTP > 7

        DO 30 I=1,3
        YAPX(I,1) = YAPX(I,2)
        YAPX(I,2) = Y(I)
        YOLD(I)   = Y(I)
        Y(I)      = YOLD(I) + D24*(55.*YP(I,4) - 59.*YP(I,3) +
     +                             37.*YP(I,2) -  9.*YP(I,1))
        YAPX(I,3) = Y(I)

        DO 20 J=1,3
   20   YP(I,J) = YP(I,J+1)
   30   CONTINUE
        RC = RDUS (   Y(1),    Y(2),    Y(3))
        RP = RDUS (YOLD(1), YOLD(2), YOLD(3))
        IF (RC .LT. RP) IAPX = 2
      ENDIF

      RETURN
      END

       SUBROUTINE FNDAPX (ALT,ZMAG,A,ALAT,ALON)

C          Find apex coordinates once tracing (in subroutine ITRACE) has
C          signalled that the apex has been passed.
C          INPUTS:
C            ALT  = Altitude of starting point
C            ZMAG = Downward component of geomagnetic field at starting point
C          OUTPUT
C            A    = Apex radius, defined as (Apex height + Req)/Req, where
C                   Req = equatorial Earth radius.
C                   A is analogous to the L value in invariant coordinates.
C            ALAT = Apex Lat. (deg)
C            ALON = Apex Lon. (deg)
C
C          COMMON BLOCKS:
C            COMMON /APXIN/  YAPX(3,3)
C            COMMON /DIPOLE/ COLAT,ELON,VP,CTP,STP
C
C          APXIN has step locations determined in ITRACE:
C            YAPX  = Matrix of cartesian coordinates (loaded columnwise) of the
C                    three points about the apex.  Set in subroutine ITRACE.
C                                                                               
C          DIPOLE has IGRF variables obtained from routines in magfld.f:
C            COLAT = Geocentric colatitude of geomagnetic dipole north pole (deg)
C            ELON  = East longitude of geomagnetic dipole north pole (deg)
C            VP    = Magnitude (T-m) of dipole component of magnetic potential at
C                    geomagnetic pole and geocentric radius of 6371.0088 km
C            CTP   = cosine of COLAT
C            STP   = sine   of COLAT
C                                                                               
C          EXTERNALS:
C            FINT = Second degree interpolation routine
C------------------------------------------------------------------------------
C          HISTORY:
C          Oct 1973: Initial version completed on the 23rd by Clark, W., NOAA
C                    Boulder.
C          Aug 1994: Revision on the 3rd by A.D. Richmond, NCAR
C          Apr 2004: Repair problem noted by Dan Weimer where the apex location
C                    produced by FINT may still have a non-zero vertical magnetic
C                    field component.

      PARAMETER (RTOD = 57.2957795130823,
     +           DTOR = .01745329251994330, REQ=6378.137)
      COMMON /APXIN/  YAPX(3,3)
      COMMON /DIPOLE/ COLAT,ELON,VP,CTP,STP
      DIMENSION BD(3), Y(3)

C          Get geodetic height and vertical (downward) component of the magnetic
C          field at last three points found by ITRACE
      DO 10 I=1,3
      RHO  = SQRT (YAPX(1,I)**2 + YAPX(2,I)**2)
      CALL CONVRT (3,GDLT,HT, RHO,YAPX(3,I))
      GDLN = RTOD*ATAN2 (YAPX(2,I),YAPX(1,I))
   10 CALL FELDG (1,GDLT,GDLN,HT, BN,BE,BD(I),BMAG)

C          Interpolate to where Bdown=0 to find cartesian coordinates at dip equator
      NITR = 0
   20 Y(1) = FINT (BD(1),BD(2),BD(3),YAPX(1,1),YAPX(1,2),YAPX(1,3), 0.)
      Y(2) = FINT (BD(1),BD(2),BD(3),YAPX(2,1),YAPX(2,2),YAPX(2,3), 0.)
      Y(3) = FINT (BD(1),BD(2),BD(3),YAPX(3,1),YAPX(3,2),YAPX(3,3), 0.)

C          Insure negligible Bdown or
C
C            |Bdown/Btot| < 2.E-6
C
C          For instance, Bdown must be less than 0.1 nT at low altitudes where
C          Btot ~ 50000 nT.  This ratio can be exceeded when interpolation is
C          not accurate; i.e., when the middle of the three points interpolated
C          is too far from the dip equator.  The three points were initially
C          defined with equal spacing by ITRACE, so replacing point 2 with the
C          most recently fit location will reduce the interpolation span.
      RHO  = SQRT (Y(1)**2 + Y(2)**2)
      GDLN = RTOD*ATAN2 (Y(2),Y(1))
      CALL CONVRT (3,GDLT,HTA, RHO,Y(3))
      CALL FELDG (1,GDLT,GDLN,HTA, BNA,BEA,BDA,BA)
      ABDOB = ABS(BDA/BA)

      IF (ABDOB .GT. 2.E-6) THEN
        IF (NITR .LT. 4) THEN        ! 4 was chosen because tests rarely required 2 iterations
          NITR      = NITR + 1
          YAPX(1,2) = Y(1)
          YAPX(2,2) = Y(2)
          YAPX(3,2) = Y(3)
          BD(2)     = BDA
          GO TO 20
        ELSE
         WRITE (0,'(''APEX: Imprecise fit of apex: |Bdown/B| ='',1PE7.1
     +    )') ABDOB
        ENDIF
      ENDIF

C          Ensure altitude of the Apex is at least the initial altitude when
C          defining the Apex radius then use it to define the Apex latitude whose
C          hemisphere (sign) is inferred from the sign of the dip angle at the
C          starting point
      A = (REQ + AMAX1(ALT,HTA)) / REQ
      IF (A .LT. 1.) THEN
        WRITE (0,'(''APEX: A can not be less than 1; A, REQ, HTA: '',1P3
     +E15.7)') A,REQ,HTA
        CALL EXIT (1)
      ENDIF
      RASQ = ACOS (SQRT(1./A))*RTOD
      ALAT = SIGN (RASQ,ZMAG)

C          ALON is the dipole longitude of the apex and is defined using
C          spherical coordinates where
C            GP   = geographic pole.
C            GM   = geomagnetic pole (colatitude COLAT, east longitude ELON).
C            XLON = longitude of apex.
C            TE   = colatitude of apex.
C            ANG  = longitude angle from GM to apex.
C            TP   = colatitude of GM.
C            TF   = arc length between GM and apex.
C            PA   = ALON be geomagnetic longitude, i.e., Pi minus angle measured
C                   counterclockwise from arc GM-apex to arc GM-GP.
C          then, spherical-trigonometry formulas for the functions of the angles
C          are as shown below.  Notation uses C=cos, S=sin and STFCPA = sin(TF) * cos(PA),
C                                                              STFSPA = sin(TF) * sin(PA)
      XLON = ATAN2 (Y(2),Y(1))
      ANG  = XLON-ELON*DTOR
      CANG = COS (ANG)
      SANG = SIN (ANG)
      R    = SQRT (Y(1)**2 + Y(2)**2 + Y(3)**2)
      CTE  = Y(3)/R
      STE  = SQRT (1.-CTE*CTE)
      STFCPA = STE*CTP*CANG - CTE*STP
      STFSPA = SANG*STE
      ALON = ATAN2 (STFSPA,STFCPA)*RTOD
      RETURN
      END                                                                      

      SUBROUTINE DIPAPX (GDLAT,GDLON,ALT,BNORTH,BEAST,BDOWN, A,ALON)

C          Compute A, ALON from local magnetic field using dipole and spherical
C          approximation.
C
C          INPUTS:
C            GDLAT  = geodetic latitude, degrees
C            GDLON  = geodetic longitude, degrees
C            ALT    = altitude, km
C            BNORTH = geodetic northward magnetic field component (any units)
C            BEAST  = eastward magnetic field component
C            BDOWN  = geodetic downward magnetic field component
C          OUTPUTS:
C            A      = apex radius, 1 + h_A/R_eq
C            ALON   = apex longitude, degrees
C
C          Use spherical coordinates and define:
C            GP    = geographic pole.
C            GM    = geomagnetic pole (colatitude COLAT, east longitude ELON).
C            G     = point at GDLAT,GDLON.
C            E     = point on sphere below apex of dipolar field line passing
C                    through G.
C            TD    = dipole colatitude of point G, found by applying dipole
C                    formula for dip angle to actual dip angle.
C            B     = Pi plus local declination angle.  B is in the direction
C                    from G to E.
C            TG    = colatitude of G.
C            ANG   = longitude angle from GM to G.
C            TE    = colatitude of E.
C            TP    = colatitude of GM.
C            A     = longitude angle from G to E.
C            APANG = A + ANG
C            PA    = geomagnetic longitude, i.e., Pi minus angle measured
C                    counterclockwise from arc GM-E to arc GM-GP.
C            TF    = arc length between GM and E.
C          Then, using notation C=cos, S=sin, COT=cot, spherical-trigonometry
C          formulas for the functions of the angles are as shown below.  Note:
C            STFCPA = sin(TF) * cos(PA)
C            STFSPA = sin(TF) * sin(PA)
C
C          COMMON BLOCKS:
C            COMMON /DIPOLE/ COLAT,ELON,VP,CTP,STP
C
C          DIPOLE has IGRF variables obtained from routines in magfld.f:
C            COLAT = Geocentric colatitude of geomagnetic dipole north pole (deg)
C            ELON  = East longitude of geomagnetic dipole north pole (deg)
C            VP    = Magnitude (T-m) of dipole component of magnetic potential at
C                    geomagnetic pole and geocentric radius of 6371.0088 km
C            CTP   = cosine of COLAT
C            STP   = sine   of COLAT
C------------------------------------------------------------------------------
C          HISTORY:
C          May 1994:  Completed on the 1st by A. D. Richmond
C          Nov 2009: Change definition of earth's mean radius (RE) from 6371.2 
C                    to the WGS84 value (6371.0088), by J.T. Emmert, NRL.

      PARAMETER (RTOD = 57.2957795130823,   RE =6371.0088,
     +           DTOR = .01745329251994330, REQ=6378.137)
      COMMON /DIPOLE/ COLAT,ELON,VP,CTP,STP

      BHOR = SQRT(BNORTH*BNORTH + BEAST*BEAST)
      IF (BHOR .EQ. 0.) THEN
        ALON = 0.
        A    = 1.E34
        RETURN
      ENDIF
      COTTD  = BDOWN*.5/BHOR
      STD    = 1./SQRT(1.+COTTD*COTTD)
      CTD    = COTTD*STD
      SB     = -BEAST /BHOR
      CB     = -BNORTH/BHOR
      CTG    = SIN (GDLAT*DTOR)
      STG    = COS (GDLAT*DTOR)
      ANG    = (GDLON-ELON)*DTOR
      SANG   = SIN(ANG)
      CANG   = COS(ANG)
      CTE    = CTG*STD + STG*CTD*CB
      STE    = SQRT(1. - CTE*CTE)
      SA     = SB*CTD/STE
      CA     = (STD*STG - CTD*CTG*CB)/STE
      CAPANG = CA*CANG - SA*SANG
      SAPANG = CA*SANG + SA*CANG
      STFCPA = STE*CTP*CAPANG - CTE*STP
      STFSPA = SAPANG*STE
      ALON = ATAN2 (STFSPA,STFCPA)*RTOD
      R    = ALT + RE
      HA   = ALT + R*COTTD*COTTD
      A    = 1. + HA/REQ
      RETURN
      END

      FUNCTION FINT (X1,X2,X3,Y1,Y2,Y3, XFIT)
C          Second degree interpolation used by FNDAPX
C          INPUTS:
C            X1   = point 1 ordinate value
C            X2   = point 2 ordinate value
C            X3   = point 3 ordinate value
C            Y1   = point 1 abscissa value
C            Y2   = point 2 abscissa value
C            Y3   = point 3 abscissa value
C            XFIT = ordinate value to fit
C          RETURNS:
C            YFIT = abscissa value corresponding to XFIT
C
C          MODIFICATIONS:
C          Apr 2004: Change from subroutine to function, rename variables and
C                    add intermediates which are otherwise calculated twice
      X12 = X1-X2
      X13 = X1-X3
      X23 = X2-X3
      XF1 = XFIT-X1
      XF2 = XFIT-X2
      XF3 = XFIT-X3

      FINT = (Y1*X23*XF2*XF3 - Y2*X13*XF1*XF3 + Y3*X12*XF1*XF2) /
     +                                                     (X12*X13*X23)
      RETURN
      END

!***************************************************************************************************
!
!  File Name: makeapexsh.f90
!  Authors: John Emmert, Art Richmond
!  Date: 11/13/2009
!  Version: 1.0
!  Description: Creates and saves spherical harmonic expansion coefficients for QD coordinate
!               conversion.
!  References: Richmond, A. D., Ionospheric Electrodynamics Using Magnetic Apex Coordinates,
!                J. Geomag. Geoelectr., 47, 191-212, 1995.
!              Emmert, J. T., A. D. Richmond, and D. P. Drob, A computationally compact 
!                representation of Magnetic-Apex and Quasi-Dipole coordinates with smooth base
!                vectors, J. Geophys. Res., 115, Axxxxx, doi:10.1029/2010JA015326, 2010.
!
!***************************************************************************************************
!
!  MAKEAPXSH
!  Computes and saves harmonic coefficients for coordinate conversions.
!
!  CALL MAKEAPXSH (DATAFILE, EPOCHS, NEPOCHS, L, M, N)
!
!  INPUT ARGUMENTS
!    DATAFILE  Name of output data file that will contain the conversion coefficients
!    EPOCHS    Array of ordered epochs (decimal years, yyyy.y) for which coefficients are to be 
!              computed.
!    NEPOCHS   Number of elements in EPOCHS.
!    L         Maximum order of vertical polynomial expansion.
!    M         Maximum order of spherical harmonic expansion.
!    N         Maximum degree of spherical harmonic expansion. N must be equal or greater than M.
!
!  DEPENDENCIES
!    apex.f, magfld.f, apexsh.f90
!
!***************************************************************************************************

subroutine makeapxsh(datafilein,epochgridin,nepochin,lmaxin,mmaxin,nmaxin)

    use apxshmodule

    implicit none

    COMMON /MAGCOF/ NMAXIGRF, GB
    
    character(128), intent(in)  :: datafilein
    real(4), intent(in)         :: epochgridin(0:30)
    integer(4), intent(in)      :: nmaxin, mmaxin, lmaxin, nepochin

    integer(4), parameter       :: sampfact=4, iun=12
    integer(4)                  :: nterm1, nlon, nlat, nalt
    integer(4)                  :: iepoch, iterm, ilon, ilat, ialt
    integer(4)                  :: l, ish, i, j, Rpt(0:2)
    real(4)                     :: glon, glat, alt, lonspace, latspace, lat0
    real(8)                     :: rhospace
    real(8)                     :: norm1, norm2, cosmplat, sinmplat, cosmplon, sinmplon
    real(8)                     :: thetag, phig, thetaq, phiq, latwgt
    real(8)                     :: xq0, yq0, zq0, xg, yg, zg
    real(8), allocatable        :: altgrid(:), altfn(:,:), shg(:)
    real(8), allocatable        :: Gg(:,:), Gq(:,:), Fg(:), Fq(:), cfdiag(:), coefftemp(:)
    real(8), allocatable        :: Dxq(:), Dyq(:), Dzq(:), Dxg(:), Dyg(:), Dzg(:)
    
    integer(4)                  :: NMAXIGRF
    real(4)                     :: GB(1:255)
    real(4)                     :: A,ALAT,ALON,dum1,dum2,dum3,dum4,dum5

    external COFRM, APEX

    !PARSE INPUT AND ALLOCATE ARRAYS
    nepoch = nepochin
    nmax = nmaxin
    mmax = mmaxin
    lmax = lmaxin
    if (mmax .gt. nmax) mmax = nmax
    ntermsh = mmax*(2*nmax - mmax + 1) + nmax + 1
    nterm = (lmax+1)*ntermsh
    nterm1 = lmax*ntermsh
    Rpt = (/nmax+1,nmax+2,1/)
    nlon = sampfact*mmax
    nlat = sampfact*nmax
    nalt = sampfact*lmax
    call allocatearrays
    coeff0 = 0
    do iepoch = 0, nepoch-1
      epochgrid(iepoch) = epochgridin(iepoch)
    enddo
    if (allocated(altgrid)) then
      deallocate(altgrid,Gg,Gq,Fg,Fq,Dxq,Dyq,Dzq,Dxg,Dyg,Dzg,shg,cfdiag,coefftemp)
    endif
    allocate(altgrid(1:nalt), altfn(0:lmax,1:nalt), shg(0:ntermsh-1))
    allocate(Gg(0:nterm1-1,0:nterm1-1), Gq(0:nterm1-1,0:nterm1-1))
    allocate(Fg(0:nterm1-1), Fq(0:nterm1-1), cfdiag(0:nterm1-1), coefftemp(0:nterm1-1))
    allocate(Dxq(0:nterm1-1), Dyq(0:nterm1-1), Dzq(0:nterm1-1))
    allocate(Dxg(0:nterm1-1), Dyg(0:nterm1-1), Dzg(0:nterm1-1))
    lonspace = 360E0 / real(nlon)
    latspace = 180E0 / real(nlat)
    lat0 = -90E0 + latspace/2D0
    rhospace = 1D0 / dble(nalt)
    norm1 = dsqrt(2D0/3D0)
    norm2 = dsqrt(4D0/3D0)

    !COMPUTE ALTITUDE BASIS FUNCTIONS
    do ialt = 1, nalt
      rho = rhospace*dble(ialt)
      altgrid(ialt) = Re / rho - Re
      altfn(0,ialt) = 1D0
      do l = 1, lmax
        altfn(l,ialt) = altfn(l-1,ialt)*rho
      enddo
    enddo

    !LOOP THROUGH EPOCHS, COMPUTE QD COORDINATE DATA AND EXPANSION COEFFICIENTS
    do iepoch = 0, nepoch-1
      print '("COMPUTING COEFFICIENTS FOR EPOCH ",f6.1)', epochgrid(iepoch)
      Gg = 0; Gq = 0
      Dxq = 0; Dyq = 0; Dzq = 0
      Dxg = 0; Dyg = 0; Dzg = 0

      !RETRIEVE IGRF, COMPUTE DIPOLE ROTATION PARAMETERS,
      !AND SET THE CORRESPONDING EXPANSION COEFFICIENTS
      call COFRM(epochgrid(iepoch))
      sinmplat = dble(GB(2) / sqrt(GB(2)*GB(2) + GB(3)*GB(3) + GB(4)*GB(4)))
      cosmplat = dsqrt(1 - sinmplat*sinmplat)
      sinmplon = dble(GB(4) / sqrt(GB(3)*GB(3) + GB(4)*GB(4)))
      cosmplon = dble(GB(3) / sqrt(GB(3)*GB(3) + GB(4)*GB(4)))
      coeff0(Rpt,iepoch,0) = (/ norm2*sinmplat*cosmplon, norm2*sinmplat*sinmplon, -norm1*cosmplat/)
      coeff0(Rpt,iepoch,1) = (/-norm2*sinmplon,          norm2*cosmplon,                      0D0/)
      coeff0(Rpt,iepoch,2) = (/ norm2*cosmplat*cosmplon, norm2*cosmplat*sinmplon,  norm1*sinmplat/)
      coeff0(Rpt,iepoch,3) = (/ norm2*sinmplat*cosmplon, -norm2*sinmplon, norm1*cosmplat*cosmplon/)
      coeff0(Rpt,iepoch,4) = (/ norm2*sinmplat*sinmplon,  norm2*cosmplon, norm1*cosmplat*sinmplon/)
      coeff0(Rpt,iepoch,5) = (/-norm2*cosmplat,                      0D0, norm1*sinmplat         /)

      !LOOP THROUGH GEODETIC LATITUDE AND LONGITUDE GRIDPOINTS
      do ilat = 0, nlat-1
        glat = latspace*real(ilat) + lat0
        thetag = (90D0 - dble(glat)) * dtor
        latwgt = dsin(thetag)
        do ilon = 0, nlon-1

          !COMPUTE SPHERICAL HARMONICS OF CURRENT GEODETIC LONGITUDE AND LATITUDE
          glon = lonspace*real(ilon) - 180E0
          phig = dble(glon) * dtor
          call shcalc(thetag,phig)
          shg = sh

          !COMPUTE REFERENCE (DIPOLE) MAGNETIC LATITUDE AND LONGITUDE OF CURRENT LOCATION
          xq0 = dot_product(coeff0(Rpt,iepoch,0),shg(Rpt))
          yq0 = dot_product(coeff0(Rpt,iepoch,1),shg(Rpt))
          zq0 = dot_product(coeff0(Rpt,iepoch,2),shg(Rpt))

          !LOOP THROUGH ALTITUDE GRIDPOINTS
          do ialt = 1, nalt

            !COMPUTE QD LATITUDE AND LONGITUDE OF CURRENT LOCATION
            alt = sngl(altgrid(ialt))
            call APEX(epochgrid(iepoch),glat,glon,alt,A,ALAT,ALON,dum1,dum2,dum3,dum4,dum5)
            cosqlat = dsqrt( (Re + altgrid(ialt)) / (Re + Req*(dble(A)-1D0)) )
            if (cosqlat .gt. 1D0) cosqlat = 1D0
            phiq = dble(ALON) * dtor        
            thetaq = dasin(cosqlat)
            if (ALAT .lt. 0) thetaq = pi - thetaq

            !COMPUTE RESIDUAL QD COORDINATES (FITTING DATA FOR GEODETIC TO QD TRANSFORMATION)
            xq = cosqlat*dcos(phiq) - xq0
            yq = cosqlat*dsin(phiq) - yq0
            zq = dcos(thetaq)       - zq0

            !COMPUTE SPHERICAL HARMONICS OF CURRENT QD LATITUDE AND LONGITUDE
            call shcalc(thetaq,phiq)

            !COMPUTE RESIDUAL GD COORDINATES (FITTING DATA FOR QD TO GEODETIC TRANSFORMATION)
            xg = latwgt*dcos(phig) - dot_product(coeff0(Rpt,iepoch,3),sh(Rpt))
            yg = latwgt*dsin(phig) - dot_product(coeff0(Rpt,iepoch,4),sh(Rpt))
            zg = dcos(thetag)      - dot_product(coeff0(Rpt,iepoch,5),sh(Rpt))

            !COMPUTE BASIS FUNCTIONS FOR GD-TO-QD AND QD-TO-GD TRANSFORMATIONS
            do l = 1, lmax
              do ish = 0, ntermsh-1
                iterm = ntermsh*(l-1) + ish
                Fg(iterm) = altfn(l,ialt)*shg(ish)
                Fq(iterm) = altfn(l,ialt)*sh(ish)
              enddo
            enddo

            !UPDATE LEAST-SQUARES ARRAYS 
            do i = 0, nterm1-1
              Dxq(i) = Dxq(i) + Fg(i)*latwgt*xq
              Dyq(i) = Dyq(i) + Fg(i)*latwgt*yq
              Dzq(i) = Dzq(i) + Fg(i)*latwgt*zq
              Dxg(i) = Dxg(i) + Fq(i)*latwgt*xg
              Dyg(i) = Dyg(i) + Fq(i)*latwgt*yg
              Dzg(i) = Dzg(i) + Fq(i)*latwgt*zg
              do j = i, nterm1-1
                Gg(i,j) = Gg(i,j) + Fg(j)*latwgt*Fg(i)
                Gq(i,j) = Gq(i,j) + Fq(j)*latwgt*Fq(i)
              enddo
            enddo

          enddo
        enddo
      enddo
      
      !COMPUTE LEAST-SQUARES SOLUTIONS USING CHOLESKY DECOMPOSITION
      call choldc(Gg,nterm1,nterm1,cfdiag)
      call cholsl(Gg,nterm1,nterm1,cfdiag,Dxq,coefftemp)
      coeff0(ntermsh:nterm-1,iepoch,0) = coefftemp
      call cholsl(Gg,nterm1,nterm1,cfdiag,Dyq,coefftemp)
      coeff0(ntermsh:nterm-1,iepoch,1) = coefftemp
      call cholsl(Gg,nterm1,nterm1,cfdiag,Dzq,coefftemp)
      coeff0(ntermsh:nterm-1,iepoch,2) = coefftemp
      call choldc(Gq,nterm1,nterm1,cfdiag)
      call cholsl(Gq,nterm1,nterm1,cfdiag,Dxg,coefftemp)
      coeff0(ntermsh:nterm-1,iepoch,3) = coefftemp
      call cholsl(Gq,nterm1,nterm1,cfdiag,Dyg,coefftemp)
      coeff0(ntermsh:nterm-1,iepoch,4) = coefftemp
      call cholsl(Gq,nterm1,nterm1,cfdiag,Dzg,coefftemp)
      coeff0(ntermsh:nterm-1,iepoch,5) = coefftemp
    enddo
    
    !WRITE COEFFICIENTS TO OUTPUT FILE
    open(unit=iun, file=trim(datafilein), form='unformatted')
    write(iun), nepoch, nmax, mmax, lmax, nterm
    write(iun), epochgrid, coeff0
    close(iun)
    
    return

end subroutine makeapxsh

!***************************************************************************************************

subroutine choldc(a,n,np,p)
  
    integer(4), intent(in)      :: n, np
    real(8), intent(inout)      :: a(1:np,1:np)
    real(8), intent(out)        :: p(1:n)
    integer(4)                  :: i, j, k
    real(8)                     :: sum

    do i = 1, n
      do j = i, n
        sum = a(i,j)
        do k = i-1, 1, -1
          sum = sum - a(i,k)*a(j,k)
        enddo
        if (i .eq. j) then
          p(i) = dsqrt(sum)
        else
          a(j,i) = sum/p(i)
        endif
      enddo
    enddo
    return

end subroutine choldc

!***************************************************************************************************

subroutine cholsl(a,n,np,p,b,x)
  
    integer(4), intent(in)      :: n, np
    real(8), intent(in)         :: a(1:np,1:np), p(1:n), b(1:n)
    real(8), intent(out)        :: x(1:n)
    integer(4)                  :: i, k
    real(8)                     :: sum

    do i = 1, n
      sum = b(i)
      do k = i-1, 1, -1
        sum = sum - a(i,k)*x(k)
      enddo
      x(i) = sum/p(i)
    enddo
    do i = n, 1, -1
      sum = x(i)
      do k = i+1, n
        sum = sum - a(k,i)*x(k)
      enddo
      x(i) = sum/p(i)
    enddo
    return

end subroutine cholsl

!***************************************************************************************************

! Uncomment below if using an Intel compiler
! use ifport

module igrf
  ! Read in relevant data from IGRF coefficient file.
  !
  ! INPUTS:
  ! filename_in = Filename for IGRF coefficient files
  !
  ! RETURNS:
  ! None (all output saved as module variables)


  implicit none

  real(8)                  :: datel
  integer(4)               :: nepo, nght
  real(8), allocatable     :: epoch(:), nmxe(:)
  real(8), allocatable     :: gyr(:,:,:), hyr(:,:,:)
  real(8), allocatable     :: gt(:,:), ht(:,:)

contains

  subroutine read_igrf(filename_in)

    implicit none

    character(len=*), intent(in) :: filename_in
    character(len=10000)         :: s
    integer(8)                   :: offset
    integer(4)                   :: state, i, pos
    integer(4)                   :: num_sh, L_max
    integer(4)                   :: num_epochs
    integer(4)                   :: l, m, e
    real(8), allocatable         :: g(:,:)
    integer(4), allocatable      :: nm(:,:)

    ! Open IGRF file
    open(unit=100, file=filename_in, status='old', iostat=state)
    if (state /= 0) then
       stop "File open error"
    end if

    ! Skip comment lines
    do
       read(unit = 100, fmt = '(A)') s
       if (s(1:1) /= '#') exit
    end do

    ! Read epochs
    num_epochs = 0
    do i=1, len_trim(s)
      if ((s(i:i+3) == 'IGRF').or.(s(i:i+3) == 'DGRF')) then
        num_epochs = num_epochs + 1
      end if
    end do
    allocate(epoch(1:num_epochs))
    allocate(nmxe(1:num_epochs))

    ! Read epochs
    read(unit = 100, fmt = '(A)', iostat = state) s
    read(s(8:), *) epoch


    ! Number of coefficients
    do i = 1, num_epochs
       if (epoch(i) .ge. 2000.0d0) then
          nmxe(i) = 13
       elseif (epoch(i) .ge. 1900.0d0) then
          nmxe(i) = 10
       else
          write(*,*) 'ERROR: Epoch unavailable!'
          exit
       end if
    end do

    ! Save file position
    offset = ftell(100)

    ! Get the number of lines (coefficients)
    num_sh = 0
    do
       read(unit = 100, fmt =*, iostat = state)
       if (state < 0) exit
       num_sh = num_sh + 1
    end do
    L_max = int(sqrt(num_sh + 1.0d0)) - 1
    close(100)

    ! Restore file position, must re-open after reaching EOF
    open(unit=100, file=filename_in, status='old', iostat=state)
    call fseek(100, offset, 0, state)

    ! Assign the variables for Gauss coefficients
    allocate(g(1:num_sh, 1:num_epochs+1))
    allocate(nm(1:num_sh, 2))

    ! Read coefficients
    do i = 1, num_sh
       read(100,*, iostat = state) s, nm(i, 1), nm(i, 2), g(i,:)
       if (state < 0) exit
    end do
    close(100)

    ! Assign the return values
    nght = (int(sqrt(num_sh + 1.0)) + 1) ** 2
    nepo = num_epochs

    ! Assign the Gauss coefficients
    allocate(gyr(nght, nght, nepo), gt(nght, nght))
    allocate(hyr(nght, nght, nepo), ht(nght, nght))
    gyr = 0.0d0
    gt = 0.0d0
    hyr = 0.0d0
    ht = 0.0d0
    do e = 1, nepo + 1
       do l = 1, L_max
          if (e .le. nepo) then
             gyr(l + 1, 1, e) = g(l ** 2, e)
          else
             gt(l + 1, 1)    = g(l ** 2, e)
          end if
          do m = 1, l
             if (m .le. l) then
                pos = 1 + m * (L_max + 2) + l
                if (e .le. nepo) then
                   gyr(l + 1, m + 1, e) = g(l ** 2 + 2 * m - 1, e)
                   hyr(l + 1, m + 1, e) = g(l ** 2 + 2 * m  , e)
                else
                   gt(l + 1, m + 1) = g(l ** 2 + 2 * m - 1, e)
                   ht(l + 1, m + 1) = g(l ** 2 + 2 * m  , e)
                end if
             end if
          end do
       end do
    end do
    return
  end subroutine read_igrf

end module igrf

! ******************************************************************************
!
! File Name: makeapexsh.f90
! Authors: John Emmert, Art Richmond
! Date: 11/13/2009
! Version: 1.0
! Description: Creates and saves spherical harmonic expansion coefficients for
! QD coordinate conversion.
! References: Richmond, A. D., Ionospheric Electrodynamics Using Magnetic Apex
! Coordinates, J. Geomag. Geoelectr., 47, 191-212, 1995.
! Emmert, J. T., A. D. Richmond, and D. P. Drob, A computationally
! compact representation of Magnetic-Apex and Quasi-Dipole
! coordinates with smooth base vectors, J. Geophys. Res., 115,
! A08322, doi:10.1029/2010JA015326, 2010.
!
! ******************************************************************************
!
! HISTORY (blame):
!
! 25 Feb 2021: Modified by Ashton Reimer to pass IGRF coefficients file to the
! cofrm and apex subroutine calls.
!
! ******************************************************************************
!
! makeapxsh
! Computes and saves harmonic coefficients for coordinate conversions.
!
! call makeapxsh(datafilein, igrffilein, epochgridin, nepochin, lmaxin, mmaxin, nmaxin)
!
! INPUT:
! datafilein  = Name of output data file that will contain the conversion
! coefficients
! igrffilein  = Name of the input IGRF coefficients file
! epochgridin = Array of ordered epochs (decimal years, yyyy.y) for which
! coefficients are to be computed.
! nepochin    = Number of elements in EPOCHS.
! lmaxin      = Maximum order of vertical polynomial expansion.
! mmaxin      = Maximum order of spherical harmonic expansion.
! nmaxin      = Maximum degree of spherical harmonic expansion. N must be equal
! or greater than M.
!
! DEPENDENCIES
! apex.f90, magfld.f90, apexsh.f90
!
! ******************************************************************************

subroutine makeapxsh(datafilein, igrffilein, epochgridin, nepochin, lmaxin, mmaxin, nmaxin)

    use apxshmodule
    use magcof

    implicit none

    character(128), intent(in)      :: datafilein
    character(len=1000), intent(in) :: igrffilein
    real(8), intent(in)             :: epochgridin(0:30)
    integer(4), intent(in)          :: nmaxin, mmaxin, lmaxin, nepochin

    integer(4), parameter       :: sampfact=4, iun=12
    integer(4)                  :: nterm1, nlon, nlat, nalt
    integer(4)                  :: iepoch, iterm, ilon, ilat, ialt
    integer(4)                  :: l, ish, i, j, Rpt(0:2)
    real(8)                     :: glon, glat, alt, lonspace, latspace, lat0
    real(8)                     :: rhospace
    real(8)                     :: norm1, norm2, cosmplat, sinmplat, cosmplon
    real(8)                     :: sinmplon
    real(8)                     :: thetag, phig, thetaq, phiq, latwgt
    real(8)                     :: xq0, yq0, zq0, xg, yg, zg
    real(8), allocatable        :: altgrid(:), altfn(:,:), shg(:)
    real(8), allocatable        :: Gg(:,:), Gq(:,:), Fg(:), Fq(:), cfdiag(:)
    real(8), allocatable        :: coefftemp(:)
    real(8), allocatable        :: Dxq(:), Dyq(:), Dzq(:), Dxg(:), Dyg(:)
    real(8), allocatable        :: Dzg(:)
    real(8)                     :: a, alat, alon, dum1, dum2, dum3, dum4, dum5

    external cofrm, apex

    ! PARSE INPUT AND ALLOCATE ARRAYS
    nepoch = nepochin
    nmax = nmaxin
    mmax = mmaxin
    lmax = lmaxin
    if (mmax > nmax) mmax = nmax
    ntermsh = mmax * (2 * nmax - mmax + 1) + nmax + 1
    nterm = (lmax + 1) * ntermsh
    nterm1 = lmax * ntermsh
    Rpt = (/ nmax + 1, nmax + 2, 1 /)
    nlon = sampfact * mmax
    nlat = sampfact * nmax
    nalt = sampfact * lmax
    call allocatearrays
    coeff0 = 0
    do iepoch = 0, nepoch - 1
      epochgrid(iepoch) = epochgridin(iepoch)
    end do
    if (allocated(altgrid)) then
      deallocate(altgrid, Gg, Gq, Fg, Fq, Dxq, Dyq, Dzq, Dxg, Dyg, Dzg, shg, cfdiag, coefftemp)
    end if
    allocate(altgrid(1:nalt), altfn(0:lmax, 1:nalt), shg(0:ntermsh - 1))
    allocate(Gg(0:nterm1 - 1, 0:nterm1 - 1), Gq(0:nterm1 - 1, 0:nterm1 - 1))
    allocate(Fg(0:nterm1 - 1), Fq(0:nterm1 - 1), cfdiag(0:nterm1 - 1), coefftemp(0:nterm1 - 1))
    allocate(Dxq(0:nterm1 - 1), Dyq(0:nterm1 - 1), Dzq(0:nterm1 - 1))
    allocate(Dxg(0:nterm1 - 1), Dyg(0:nterm1 - 1), Dzg(0:nterm1 - 1))
    lonspace = 360E0 / real(nlon)
    latspace = 180E0 / real(nlat)
    lat0 = - 90E0 + latspace / 2D0
    rhospace = 1D0 / dble(nalt)
    norm1 = dsqrt(2D0 / 3D0)
    norm2 = dsqrt(4D0 / 3D0)

    ! COMPUTE ALTITUDE BASIS FUNCTIONS
    do ialt = 1, nalt
      rho = rhospace * dble(ialt)
      altgrid(ialt) = Re / rho - Re
      altfn(0, ialt) = 1D0
      do l = 1, lmax
        altfn(l, ialt) = altfn(l - 1, ialt) * rho
      end do
    end do

    ! LOOP THROUGH EPOCHS, COMPUTE QD COORDINATE DATA AND EXPANSION COEFFICIENTS
    do iepoch = 0, nepoch - 1
      print '("COMPUTING COEFFICIENTS FOR EPOCH ",f6.1)', epochgrid(iepoch)
      Gg = 0; Gq = 0
      Dxq = 0; Dyq = 0; Dzq = 0
      Dxg = 0; Dyg = 0; Dzg = 0

      ! Retrieve IGRF
      call cofrm(epochgrid(iepoch), igrffilein)

      ! Compute the dipole rotation parameters
      sinmplat = dble(gb(2) / sqrt(gb(2) * gb(2) + gb(3) * gb(3) + gb(4) * gb(4)))
      cosmplat = dsqrt(1 - sinmplat * sinmplat)
      sinmplon = dble(gb(4) / sqrt(gb(3) * gb(3) + gb(4) * gb(4)))
      cosmplon = dble(gb(3) / sqrt(gb(3) * gb(3) + gb(4) * gb(4)))

      ! Set the expansion coeficients
      coeff0(Rpt, iepoch, 0) = (/ norm2 * sinmplat * cosmplon, norm2 * sinmplat * sinmplon, - norm1 * cosmplat /)
      coeff0(Rpt, iepoch, 1) = (/- norm2 * sinmplon,          norm2 * cosmplon,                      0D0 /)
      coeff0(Rpt, iepoch, 2) = (/ norm2 * cosmplat * cosmplon, norm2 * cosmplat * sinmplon,  norm1 * sinmplat /)
      coeff0(Rpt, iepoch, 3) = (/ norm2 * sinmplat * cosmplon, - norm2 * sinmplon, norm1 * cosmplat * cosmplon /)
      coeff0(Rpt, iepoch, 4) = (/ norm2 * sinmplat * sinmplon,  norm2 * cosmplon, norm1 * cosmplat * sinmplon /)
      coeff0(Rpt, iepoch, 5) = (/- norm2 * cosmplat,                      0D0, norm1 * sinmplat         /)

      ! LOOP THROUGH GEODETIC LATITUDE AND LONGITUDE GRIDPOINTS
      do ilat = 0, nlat - 1
        glat = latspace * real(ilat) + lat0
        thetag = (90D0 - dble(glat)) * dtor
        latwgt = dsin(thetag)
        ! print *, 'LINE 156'!, latwgt
        do ilon = 0, nlon - 1

          ! COMPUTE SPHERICAL HARMONICS OF CURRENT GEODETIC LONGITUDE AND
          ! LATITUDE
          glon = lonspace * real(ilon) - 180E0
          phig = dble(glon) * dtor
          call shcalc(thetag, phig)
          shg = sh
          ! COMPUTE REFERENCE (DIPOLE) MAGNETIC LATITUDE AND LONGITUDE OF
          ! CURRENT LOCATION
          xq0 = dot_product(coeff0(Rpt, iepoch, 0), shg(Rpt))
          yq0 = dot_product(coeff0(Rpt, iepoch, 1), shg(Rpt))
          zq0 = dot_product(coeff0(Rpt, iepoch, 2), shg(Rpt))
          ! LOOP THROUGH ALTITUDE GRIDPOINTS
          do ialt = 1, nalt
            ! COMPUTE QD LATITUDE AND LONGITUDE OF CURRENT LOCATION
            alt = sngl(altgrid(ialt))
            call apex(epochgrid(iepoch), igrffilein, glat, glon, alt, a, alat, alon, dum1, dum2, dum3, dum4, dum5)
            cosqlat = dsqrt( (Re + altgrid(ialt)) / (Re + Req * (dble(a) - 1D0)) )
            if (cosqlat > 1D0) cosqlat = 1D0
            phiq = dble(alon) * dtor
            thetaq = dasin(cosqlat)
            if (alat < 0) thetaq = pi - thetaq
            ! COMPUTE RESIDUAL QD COORDINATES (FITTING DATA FOR GEODETIC TO QD
            ! TRANSFORMATION)
            xq = cosqlat * dcos(phiq) - xq0
            yq = cosqlat * dsin(phiq) - yq0
            zq = dcos(thetaq)       - zq0
            ! COMPUTE SPHERICAL HARMONICS OF CURRENT QD LATITUDE AND LONGITUDE
            call shcalc(thetaq, phiq)
            ! COMPUTE RESIDUAL GD COORDINATES (FITTING DATA FOR QD TO GEODETIC
            ! TRANSFORMATION)
            xg = latwgt * dcos(phig) - dot_product(coeff0(Rpt, iepoch, 3), sh(Rpt))
            yg = latwgt * dsin(phig) - dot_product(coeff0(Rpt, iepoch, 4), sh(Rpt))
            zg = dcos(thetag)      - dot_product(coeff0(Rpt, iepoch, 5), sh(Rpt))
            ! COMPUTE BASIS FUNCTIONS FOR GD-TO-QD AND QD-TO-GD TRANSFORMATIONS
            do l = 1, lmax
              do ish = 0, ntermsh - 1
                iterm = ntermsh * (l - 1) + ish
                Fg(iterm) = altfn(l, ialt) * shg(ish)
                Fq(iterm) = altfn(l, ialt) * sh(ish)
              end do
            end do
            ! UPDATE LEAST-SQUARES ARRAYS
            do i = 0, nterm1 - 1
              Dxq(i) = Dxq(i) + Fg(i) * latwgt * xq
              Dyq(i) = Dyq(i) + Fg(i) * latwgt * yq
              Dzq(i) = Dzq(i) + Fg(i) * latwgt * zq
              Dxg(i) = Dxg(i) + Fq(i) * latwgt * xg
              Dyg(i) = Dyg(i) + Fq(i) * latwgt * yg
              Dzg(i) = Dzg(i) + Fq(i) * latwgt * zg
              do j = i, nterm1 - 1
                Gg(i, j) = Gg(i, j) + Fg(j) * latwgt * Fg(i)
                Gq(i, j) = Gq(i, j) + Fq(j) * latwgt * Fq(i)
              end do
            end do
          end do
        end do
      end do
      ! COMPUTE LEAST-SQUARES SOLUTIONS USING CHOLESKY DECOMPOSITION
      call choldc(Gg, nterm1, nterm1, cfdiag)
      call cholsl(Gg, nterm1, nterm1, cfdiag, Dxq, coefftemp)

      coeff0(ntermsh:nterm - 1, iepoch, 0) = coefftemp
      call cholsl(Gg, nterm1, nterm1, cfdiag, Dyq, coefftemp)
      coeff0(ntermsh:nterm - 1, iepoch, 1) = coefftemp
      call cholsl(Gg, nterm1, nterm1, cfdiag, Dzq, coefftemp)
      coeff0(ntermsh:nterm - 1, iepoch, 2) = coefftemp

      call choldc(Gq, nterm1, nterm1, cfdiag)
      call cholsl(Gq, nterm1, nterm1, cfdiag, Dxg, coefftemp)
      coeff0(ntermsh:nterm - 1, iepoch, 3) = coefftemp
      call cholsl(Gq, nterm1, nterm1, cfdiag, Dyg, coefftemp)
      coeff0(ntermsh:nterm - 1, iepoch, 4) = coefftemp
      call cholsl(Gq, nterm1, nterm1, cfdiag, Dzg, coefftemp)
      coeff0(ntermsh:nterm - 1, iepoch, 5) = coefftemp
    end do

    ! WRITE COEFFICIENTS TO OUTPUT FILE
    open(unit=iun, file=trim(datafilein), form='unformatted')
    write(iun) nepoch, nmax, mmax, lmax, nterm
    write(iun) epochgrid, coeff0
    close(iun)

    return

end subroutine makeapxsh

! ******************************************************************************

subroutine choldc(a, n, np, p)

    integer(4), intent(in)      :: n, np
    real(8), intent(inout)      :: a(1:np, 1:np)
    real(8), intent(out)        :: p(1:n)
    integer(4)                  :: i, j, k
    real(8)                     :: sum

    do i = 1, n
      do j = i, n
        sum = a(i, j)
        do k = i - 1, 1, - 1
          sum = sum - a(i, k) * a(j, k)
        end do
        if (i == j) then
          p(i) = dsqrt(sum)
        else
          a(j, i) = sum / p(i)
        end if
      end do
    end do
    return

end subroutine choldc

! ******************************************************************************

subroutine cholsl(a, n, np, p, b, x)

    integer(4), intent(in)      :: n, np
    real(8), intent(in)         :: a(1:np, 1:np), p(1:n), b(1:n)
    real(8), intent(out)        :: x(1:n)
    integer(4)                  :: i, k
    real(8)                     :: sum

    do i = 1, n
      sum = b(i)
      do k = i - 1, 1, - 1
        sum = sum - a(i, k) * x(k)
      end do
      x(i) = sum / p(i)
    end do
    do i = n, 1, - 1
      sum = x(i)
      do k = i + 1, n
        sum = sum - a(k, i) * x(k)
      end do
      x(i) = sum / p(i)
    end do
    return

end subroutine cholsl

! ******************************************************************************

! **********************************************
!
! File Name: magfld.f90
! Authors:
! Translated to Fortran 90 by Leslie Lamarche
! Date: 01/27/2022
!
! ***********************************************


module magcof

  implicit none

  integer(4)       :: nmax1
  real(8)          :: ichg
  real(8)          :: gb(225), gv(225)

end module magcof

module coeffmodule
  ! Req = Equatorial radius of Earth in km (WGS84 value)
  ! eps = flatness of ellipsoidal Earth (WGS84 value)
  ! Re = Mean radius of Earth in km
  ! ecc2 = squared eccentricity of ellipsoidal Earth
  real(8), parameter       :: pi=3.14159265358979323846D0
  real(8), parameter       :: dtor=pi / 180D0, rtod=180D0 / pi, pid2=pi / 2D0, twopi=2D0 * pi
  real(8), parameter       :: Req=6378.1370D0, Rep = 6356.7520D0
  real(8), parameter       :: eps=1.D0 / 298.257223563D0, Re=Req * (1 - eps / 3D0)
  ! real(8), parameter       :: ecc2 = 1D0 - (Rep / Req)
  real(8), parameter       :: ecc2 = eps * (2D0 - eps)
  real(8), parameter       :: missing=- 9999E0
end module coeffmodule


subroutine cofrm(date, filename)

  ! Define the International Geomagnetic Reference Field (IGRF) as a
  ! scalar potential field using a truncated series expansion with
  ! Schmidt semi-normalized associated Legendre functions of degree n and
  ! order m.  The polynomial coefficients are a function of time and are
  ! interpolated between five year epochs or extrapolated at a constant
  ! rate after the last epoch.
  !
  ! INPUTS:
  ! date = yyyy.fraction (UT)
  ! fielname = filename for IGRF coefficient file
  ! OUTPUTS (variables in imported module magcof):
  ! nmax1 = Maximum order of spherical harmonic coefficients used
  ! gb   = Coefficients for magnetic field calculation
  ! gv   = Coefficients for magnetic potential calculation
  ! ichg = Flag indicating when gb,gv have been changed in cofrm
  !
  ! It is fatal to supply a date before the first epoch.  A warning is
  ! issued to Fortran unit 0 (stderr) if date is later than the
  ! recommended limit, five years after the last epoch.
  !
  ! HISTORY (blame):
  ! Apr 1983:  Written by Vincent B. Wickwar (Utah State Univ.) including
  ! secular variation acceleration rate set to zero in case the IGRF
  ! definition includes such second time derivitives.  The maximum degree
  ! (n) defined was 10.
  !
  ! Jun 1986:  Updated coefficients adding Definitive Geomagnetic Reference
  ! Field (DGRF) for 1980 and IGRF for 1985 (EOS Volume 7 Number 24).  The
  ! designation DGRF means coefficients will not change in the future
  ! whereas IGRF coefficients are interim pending incorporation of new
  ! magnetometer data.  Common block MAG was replaced by MAGCOF, thus
  ! removing variables not used in subroutine FELDG.  (Roy Barnes)
  !
  ! Apr 1992 (Barnes):  Added DGRF 1985 and IGRF 1990 as given in EOS
  ! Volume 73 Number 16 April 21 1992.  Other changes were made so future
  ! updates should:  (1) Increment NDGY; (2) Append to EPOCH the next IGRF
  ! year; (3) Append the next DGRF coefficients to G1DIM and H1DIM; and (4)
  ! replace the IGRF initial values (G0, GT) and rates of change indices
  ! (H0, HT).
  !
  ! Apr 1994 (Art Richmond): Computation of GV added, for finding magnetic
  ! potential.
  !
  ! Aug 1995 (Barnes):  Added DGRF for 1990 and IGRF for 1995, which were
  ! obtained by anonymous ftp to geomag.gsfc.nasa.gov (cd pub, mget table*)
  ! as per instructions from Bob Langel (langel@geomag.gsfc.nasa.gov) with
  ! problems reported to baldwin@geomag.gsfc.nasa.gov.
  !
  ! Oct 1995 (Barnes):  Correct error in IGRF-95 G 7 6 and H 8 7 (see email
  ! in folder).  Also found bug whereby coefficients were not being updated
  ! in FELDG when IENTY did not change so ICHG was added to flag date
  ! changes.  Also, a vestigial switch (IS) was removed from COFRM; it was
  ! always zero and involved 3 branch if statements in the main polynomial
  ! construction loop now numbered 200.
  !
  ! Feb 1999 (Barnes):  Explicitly initialize GV(1) in COFRM to avoid the
  ! possibility of compiler or loader options initializing memory to
  ! something else (e.g., indefinite).  Also simplify the algebra in COFRM
  ! with no effect on results.
  !
  ! Mar 1999 (Barnes):  Removed three branch if's from FELDG and changed
  ! statement labels to ascending order.
  !
  ! Jun 1999 (Barnes):  Corrected RTOD definition in GD2CART.
  !
  ! May 2000 (Barnes):  Replace IGRF 1995, add IGRF 2000, and extend the
  ! earlier DGRF's back to 1900.  The coefficients came from an NGDC web
  ! page.  Related documentation is in $APXROOT/docs/igrf.2000.*  where
  ! $APXROOT, defined by 'source envapex', is traditionally ~bozo/apex).
  !
  ! Mar 2004 (Barnes):  Replace 1995 and 2000 coefficients; now both are
  ! DGRF.  Coefficients for 2000 are degree 13 with precision increased to
  ! tenths nT and accommodating this instigated changes:  (1) degree (NMAX)
  ! is now a function of epoch (NMXE) to curtail irrelevant looping over
  ! unused high order terms (n > 10 in epochs before 2000) when calculating
  ! GB; (2) expand coefficients data statement layout for G1D and H1D,
  ! formerly G1DIM and H1DIM; (3) omit secular variation acceleration terms
  ! which were always zero; (4) increase array dimensions in common block
  ! MAGCOF and associated arrays G and H in FELDG; (5) change earth's shape
  ! in CONVRT from the IAU-1966 to the WGS-1984 spheroid; (6) eliminate
  ! reference to 'definitive' in variables in COFRM which were not always
  ! definitive; (7) change G to GB in COFRM s.t. arrays GB and GV in common
  ! block MAGCOF are consistently named in all subroutines; (8) remove
  ! unused constants in all five subroutines.  See EOS Volume 84 Number 46
  ! November 18 2003, www.ngdc.noaa.gov/IAGA/vmod/igrf.html or local files
  ! $APXROOT/docs/igrf.2004.*
  !
  ! Sept. 2005 (Maute): update with IGRF10 from
  ! http://www.ngdc.noaa.gov/IAGA/vmod/igrf.html use script
  ! ~maute/apex.d/apex_update/igrf2f Note that the downloaded file the start
  ! column of the year in the first line has to be before the start of each
  ! number in the same column
  !
  ! Jan. 2010 (Maute) update with IGRF11 (same instructions as Sep. 2005
  ! comment
  !
  ! May 2020 (Achim Morschhauser): Update with routine to read
  ! IGRF coefficients file directly.
  !
  ! Jul 2022 (Lamarche): Revise to fortran 90 standards


    use magcof
    use igrf

    implicit none

    real(8), intent(in)              :: date
    character(len=1000), intent(in)  :: filename
    real(8)                          :: f, f0, t, to5
    integer(4)                       :: i, i1, iy, iy1, m, n, mm, nn, ngh


    ! Do not need to load new coefficients if date has not changed
    ichg = 0
    if (date == datel) then
      return
    else
      datel = date
      ichg = 1
    end if

    ! Read in the IGRF file, if it has not already been loaded
    if (.not. allocated(gyr)) then
      call read_igrf(filename)
    end if
    ngh = nght * nepo

    ! Test the desired output epoch
    if (date < epoch(1)) then
      write(0, '("COFRM:  DATE "(F9.3)" preceeds earliest available "(F6.1))') date, epoch(1)
      call exit(1)
    elseif (date > epoch(nepo) + 5.) then
      write(0, '("COFRM:  DATE "(F9.3)" is after the last recommended for extrapolation "(F6.1))') date, epoch(1) + 5.
      call exit(1)
    end if

    ! Set the date and time index
    do iy = 1, nepo
      if (date < epoch(iy)) exit
    end do
    iy = iy - 1

    ngh = nght * nepo
    nmax1 = int(nmxe(iy))
    ! time = date
    t = date - epoch(iy)
    to5 = t / 5.
    iy1 = iy + 1
    gb(1) = 0.0
    gv(1) = 0.0
    i = 2
    f0 = - 1.0d-5

    do n = 1, nmax1
      f0 = f0 * real(n) / 2.
      f = f0 / sqrt(2.0)
      nn = n + 1
      mm = 1

      if (iy < nepo) then  ! interoplate (m=0 terms)
        gb(i) = (gyr(nn, mm, iy) + (gyr(nn, mm, iy1) - gyr(nn, mm, iy)) * to5) * f0
      end if
      if (iy == nepo) then  ! extrapolate (m=0 terms)
        gb(i) = (gyr(nn, mm, iy) + gt(nn, mm) * t) * f0
      end if
      gv(i) = gb(i) / real(nn)
      i = i + 1
      do m = 1, n
        f = f / sqrt(real(n - m + 1) / real(n + m))
        nn = n + 1
        mm = m + 1
        i1 = i + 1
        if (iy < nepo) then  ! interpolate (m>0 terms)
          gb(i) = (gyr(nn, mm, iy) + (gyr(nn, mm, iy1) - gyr(nn, mm, iy)) * to5) * f
          gb(i1) = (hyr(nn, mm, iy) + (hyr(nn, mm, iy1) - hyr(nn, mm, iy)) * to5) * f
        else                    ! extrapolate (m>0 terms)
          gb(i) = (gyr(nn, mm, iy) + gt(nn, mm) * t) * f
          gb(i1) = (hyr(nn, mm, iy) + ht(nn, mm) * t) * f
        end if
        gv(i) = gb(i) / real(nn)
        gv(i1) = gb(i1) / real(nn)
        i = i + 2
      end do
    end do

    return
end subroutine cofrm


subroutine dypol(colat, elon, vp)

  ! Computes parameters for dipole component of geomagnetic field.
  ! cofrm must be called before calling dypol!
  ! 940504 A. D. Richmond
  !
  ! INPUTS (variables in imported module magcof):
  ! nmax1 = Maximum order of spherical harmonic coefficients used
  ! gb   = Coefficients for magnetic field calculation
  ! gv   = Coefficients for magnetic potential calculation
  ! ichg = Flag indicating when gb,gv have been changed
  !
  ! RETURNS:
  ! colat = Geocentric colatitude of geomagnetic dipole north pole
  ! (deg)
  ! elon  = East longitude of geomagnetic dipole north pole (deg)
  ! vp    = Magnitude, in T.m, of dipole component of magnetic
  ! potential at geomagnetic pole and geocentric radius
  ! of 6371.2 km
  !
  ! IMPORTS:
  ! magcof
  ! coeffmodule


  use magcof
  use coeffmodule

  implicit none

  real(8), intent(out)      :: colat, elon, vp
  real(8)                   :: ctp, gpl, stp

  ! Compute geographic colatitude and logitude of the north pole of earth centered dipole
  gpl = sqrt(gb(2) ** 2 + gb(3) ** 2 + gb(4) ** 2)
  ctp = gb(2) / gpl
  stp = sqrt(1 - ctp * ctp)
  colat = acos(ctp) * rtod
  elon = atan2(gb(4), gb(3)) * rtod

  ! Compute magnitude of magnetic potential at pole, radius Re
  vp = 0.2 * gpl * Re
  ! .2 = 2*(10**-4 T/gauss)*(1000 m/km) (2 comes through f0 in cofrm).

  return
end subroutine dypol


subroutine feldg(ienty, glat, glon, alt, bnrth, beast, bdown, babs)

  ! Compute the DGRF/IGRF field components at the point glat,glon,alt.
  ! cofrm must be called to establish coefficients for correct date
  ! prior to calling feldg.
  !
  ! ienty is an input flag controlling the meaning and direction of the
  ! remaining formal arguments:
  ! ienty = 1
  ! INPUTS:
  ! glat = Latitude of point (deg)
  ! glon = Longitude (east=+) of point (deg)
  ! alt  = Ht of point (km)
  ! RETURNS:
  ! bnrth = north component of field vector (Gauss)
  ! beast = east component of field vector  (Gauss)
  ! bdown = downward component of field vector (Gauss)
  ! babs  = magnitude of field vector (Gauss)
  !
  ! ienty = 2
  ! INPUTS:
  ! glat = X coordinate (in units of earth radii 6371.2 km )
  ! glon = Y coordinate (in units of earth radii 6371.2 km )
  ! alt  = Z coordinate (in units of earth radii 6371.2 km )
  ! RETURNS:
  ! bnrth = X component of field vector (Gauss)
  ! beast = Y component of field vector (Gauss)
  ! bdown = Z component of field vector (Gauss)
  ! babs  = Magnitude of field vector (Gauss)
  !
  ! ienty = 3
  ! INPUTS:
  ! glat = X coordinate (in units of earth radii 6371.2 km )
  ! glon = Y coordinate (in units of earth radii 6371.2 km )
  ! alt  = Z coordinate (in units of earth radii 6371.2 km )
  ! RETURNS:
  ! bnrth = Dummy variable
  ! beast = Dummy variable
  ! bdown = Dummy variable
  ! babs  = Magnetic potential (T.m)
  !
  ! INPUTS (variables in imported module magcof):
  ! nmax1 = Maximum order of spherical harmonic coefficients used
  ! gb    = Coefficients for magnetic field calculation
  ! gv    = Coefficients for magnetic potential calculation
  ! ichg  = Flag indicating when GB,GV have been changed
  !
  ! HISTORY:
  ! Apr 1983: written by Vincent B. Wickwar (Utah State Univ.).
  !
  ! May 1994 (A.D. Richmond): Added magnetic potential calculation
  !
  ! Oct 1995 (Barnes): Added ICHG
  !
  ! Jul 2022 (Lamarche): Revise to fortran 90 standards


  use magcof
  use coeffmodule

  implicit none

  integer(4), intent(in) :: ienty
  real(8), intent(in)    :: glat, glon, alt
  real(8), intent(out)   :: bnrth, beast, bdown, babs
  integer(4)             :: ientyp, ih, ihm, ihmax, il, ilm, imax
  integer(4)             :: is, k, last, m, mk, i
  real(8)                :: brho, bxxx, byyy, bzzz, cp, sp, ct, st, f
  real(8)                :: rlat, rlon, rq, s, t, x, xxx, y, yyy, z, zzz
  real(8)                :: g(255), h(255), xi(3)

  ientyp = - 10000

  if (ienty == 1) then
    is = 1
    rlat = glat * dtor
    ct = sin(rlat)
    st = cos(rlat)
    rlon = glon * dtor
    cp = cos(rlon)
    sp = sin(rlon)
    call gd2cart(glat, glon, alt, xxx, yyy, zzz)
    xxx = xxx / Re
    yyy = yyy / Re
    zzz = zzz / Re
  else
    is = 2
    xxx = glat
    yyy = glon
    zzz = alt
  end if
  rq = 1./ (xxx ** 2 + yyy ** 2 + zzz ** 2)
  xi(1) = xxx * rq
  xi(2) = yyy * rq
  xi(3) = zzz * rq
  ihmax = nmax1 * nmax1 + 1
  last = ihmax + nmax1 + nmax1
  imax = nmax1 + nmax1 - 1

  ! ientyp is not saved between calls, so this will always be run
  ! This may be incorrect?
  if (ienty /= ientyp .or. ichg == 1) then
    ientyp = ienty
    ichg = 0
    if (ienty /= 3) then
      do i = 1, last
        g(i) = gb(i)
      end do
    else
      do i = 1, last
        g(i) = gv(i)
      end do
    end if
  end if

  do i = ihmax, last
    h(i) = g(i)
  end do

  mk = 3
  if (imax == 1) mk = 1

  do k = 1, mk, 2
    i = imax
    ih = ihmax
    do while (i .ge. k)
      il = ih - i
      f = 2./ FLOAT(i - k + 2)
      x = xi(1) * f
      y = xi(2) * f
      z = xi(3) * (f + f)

      i = i - 2
      if (i > 1) then
        do m = 3, i, 2
          ihm = ih + m
          ilm = il + m
          h(ilm + 1) = g(ilm + 1) + z * h(ihm + 1) + x * (h(ihm + 3) - h(ihm - 1)) - y * (h(ihm + 2) + h(ihm - 2))
          h(ilm)   = g(ilm)  + z * h(ihm)   + x * (h(ihm + 2) - h(ihm - 2)) + y * (h(ihm + 3) + h(ihm - 1))
        end do
        h(il + 2) = g(il + 2) + z * h(ih + 2) + x * h(ih + 4) - y * (h(ih + 3) + h(ih))
        h(il + 1) = g(il + 1) + z * h(ih + 1) + y * h(ih + 4) + x * (h(ih + 3) - h(ih))
      elseif (i == 1) then
        h(il + 2) = g(il + 2) + z * h(ih + 2) + x * h(ih + 4) - y * (h(ih + 3) + h(ih))
        h(il + 1) = g(il + 1) + z * h(ih + 1) + y * h(ih + 4) + x * (h(ih + 3) - h(ih))
      end if
      h(il) = g(il) + z * h(ih) + 2.* (x * h(ih + 1) + y * h(ih + 2))
      ih = il
    end do
  end do

  s = .5 * h(1) + 2.* (h(2) * xi(3) + h(3) * xi(1) + h(4) * xi(2))
  t = (rq + rq) * sqrt(rq)
  bxxx = t * (h(3) - s * xxx)
  byyy = t * (h(4) - s * yyy)
  bzzz = t * (h(2) - s * zzz)
  babs = sqrt(bxxx ** 2 + byyy ** 2 + bzzz ** 2)
  if (is == 1) then            ! (convert back to geodetic)
    beast = byyy * cp - bxxx * sp
    brho  = byyy * sp + bxxx * cp
    bnrth = bzzz * st - brho * ct
    bdown = - bzzz * ct - brho * st
  elseif (is == 2) then        ! (leave in earth centered cartesian)
    bnrth = bxxx
    beast = byyy
    bdown = bzzz
  end if

  ! Magnetic potential computation makes use of the fact that the
  ! calculation of V is identical to that for r*Br, if coefficients
  ! in the latter calculation have been divided by (n+1) (coefficients
  ! GV).  Factor .1 converts km to m and gauss to tesla.
  if (ienty == 3) babs = (bxxx * xxx + byyy * yyy + bzzz * zzz) * Re *.1

  return
end subroutine feldg


subroutine gd2cart(gdlat, glon, alt, x, y, z)

  ! Convert geodetic to cartesian coordinates by calling CONVRT
  ! 940503 A. D. Richmond

  use magcof
  use coeffmodule

  implicit none

  real(8), intent(in)     :: gdlat, glon, alt
  real(8), intent(out)    :: x, y, z
  real(8)                 :: ang, rho

  call convrt(1, gdlat, alt, rho, z)
  ang = glon * dtor
  x = rho * cos(ang)
  y = rho * sin(ang)

  return
end subroutine gd2cart


subroutine convrt(i, gdlat, alt, x1, x2)

  ! Convert space point from geodetic to geocentric or vice versa.
  !
  ! i is an input flag controlling the meaning and direction of the
  ! remaining formal arguments:
  !
  ! i = 1  (convert from geodetic to cylindrical geocentric)
  ! INPUTS:
  ! gdlat = Geodetic latitude (deg)
  ! alt   = Altitude above reference ellipsoid (km)
  ! RETURNS:
  ! x1    = Distance from Earth's rotation axis (km)
  ! x2    = Distance above (north of) Earth's equatorial plane (km)
  !
  ! i = 2  (convert from geodetic to spherical geocentric)
  ! INPUTS:
  ! gdlat = Geodetic latitude (deg)
  ! alt   = Altitude above reference ellipsoid (km)
  ! RETURNS:
  ! x1    = Geocentric latitude (deg)
  ! x2    = Geocentric distance (km)
  !
  ! i = 3  (convert from cylindrical geocentric to geodetic)
  ! INPUTS:
  ! x1    = Distance from Earth's rotation axis (km)
  ! x2    = Distance from Earth's equatorial plane (km)
  ! RETURNS:
  ! gdlat = Geodetic latitude (deg)
  ! alt   = Altitude above reference ellipsoid (km)
  !
  ! i = 4  (convert from spherical geocentric to geodetic)
  ! INPUTS:
  ! x1    = Geocentric latitude (deg)
  ! x2    = Geocentric distance (km)
  ! RETURNS:
  ! gdlat = Geodetic latitude (deg)
  ! alt   = Altitude above reference ellipsoid (km)
  !
  !
  ! HISTORY:
  ! 940503 (A. D. Richmond):  Based on a routine originally written
  ! by V. B. Wickwar.
  !
  ! Mar 2004: (Barnes) Revise spheroid definition to WGS-1984 to conform
  ! with IGRF-9 release (EOS Volume 84 Number 46 November 18 2003).
  !
  ! Jul 2022 (Lamarche): Revise to fortran 90 standards
  !
  ! REFERENCE: ASTRON. J. VOL. 66, p. 15-16, 1961


  use magcof
  use coeffmodule

  implicit none

  integer(4), intent(in) :: i
  real(8)                :: gdlat, alt, x1, x2
  real(8)                :: a2, a4, a6, a8, c2cl, c4cl, ccl, coslat, sinlat, d, dltcl
  real(8)                :: gclat, rho, ri, rkm, s2cl, s4cl, s6cl, s8cl, scl, sgl, z

  ! A lot of these are the related to Req and esp - remove reduncancy
  real(8), parameter :: e2 = ecc2, e4 = e2 * e2, e6 = e4 * e2, e8 = e4 * e4,           &
                     ome2req = (1.- e2) * Req,                                     &
                     a21 = (512.* e2 + 128.* e4 + 60.* e6 + 35.* e8) / 1024.,         &
                     a22 = (e6 + e8) / 32., a23 = (e6 + e8) / 32.,                    &
                     a41 = - (64.* e4 + 48.* e6 + 35.* e8) / 1024.,                   &
                     a42 = (4.* e4 + 2.* e6 + e8) / 16., a43 = 15.* e8 / 256.,         &
                     a44 = - e8 / 16., a61 = 3.* (4.* e6 + 5.* e8) / 1024.,             &
                     a62 = - 3.* (e6 + e8) / 32., a63 = 35.* (4.* e6 + 3.* e8) / 768.,   &
                     a81 = - 5.* e8 / 2048., a82 = 64.* e8 / 2048.,                    &
                     a83 = - 252.* e8 / 2048., a84 = 320.* e8 / 2048.

  if (i < 3) then
    ! Geodetic to Geocentric
    ! Compute rho, z
    sinlat = sin(gdlat * dtor)
    coslat = sqrt(1.- sinlat * sinlat)
    d = sqrt(1.- e2 * sinlat * sinlat)
    z = (alt + ome2req / d) * sinlat
    rho = (alt + req / d) * coslat
    x1 = rho
    x2 = z
    if (i == 1) return

    ! Compute gclat, rkm
    rkm = sqrt(z * z + rho * rho)
    gclat = rtod * atan2(z, rho)
    x1 = gclat
    x2 = rkm
    return
  end if

  if (i == 3) then
    ! Geocentric to geodetic
    rho = x1
    z = x2
    rkm = sqrt(z * z + rho * rho)
    scl = z / rkm
    gclat = asin(scl) * rtod
  elseif (i == 4) then
    gclat = x1
    rkm = x2
    scl = sin(gclat * dtor)
  else
    return
  end if

  ri = req / rkm
  a2 = ri * (a21 + ri * (a22 + ri * a23))
  a4 = ri * (a41 + ri * (a42 + ri * (a43 + ri * a44)))
  a6 = ri * (a61 + ri * (a62 + ri * a63))
  a8 = ri * (a81 + ri * (a82 + ri * (a83 + ri * a84)))
  ccl = sqrt(1.- scl * scl)
  s2cl = 2.* scl * ccl
  c2cl = 2.* ccl * ccl - 1.
  s4cl = 2.* s2cl * c2cl
  c4cl = 2.* c2cl * c2cl - 1.
  s8cl = 2.* s4cl * c4cl
  s6cl = s2cl * c4cl + c2cl * s4cl
  dltcl = s2cl * a2 + s4cl * a4 + s6cl * a6 + s8cl * a8
  gdlat = dltcl * rtod + gclat
  sgl = sin(gdlat * dtor)
  alt = rkm * cos(dltcl) - req * sqrt(1.- e2 * sgl * sgl)
  return

end subroutine convrt

!     -*- f90 -*-
!     This file is autogenerated with f2py (version:1.20.2)
!     It contains Fortran 90 wrappers to fortran functions.

      subroutine f2py_apxshmodule_getdims_coeff0(r,s,f2pysetdata,flag)
      use apxshmodule, only: d => coeff0

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2),s(3)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_apxshmodule_getdims_coeff0
      subroutine f2py_apxshmodule_getdims_qcoeff0(r,s,f2pysetdata,flag)
      use apxshmodule, only: d => qcoeff0

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_apxshmodule_getdims_qcoeff0
      subroutine f2py_apxshmodule_getdims_gcoeff0(r,s,f2pysetdata,flag)
      use apxshmodule, only: d => gcoeff0

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_apxshmodule_getdims_gcoeff0
      subroutine f2py_apxshmodule_getdims_xqcoeff(r,s,f2pysetdata,flag)
      use apxshmodule, only: d => xqcoeff

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_apxshmodule_getdims_xqcoeff
      subroutine f2py_apxshmodule_getdims_yqcoeff(r,s,f2pysetdata,flag)
      use apxshmodule, only: d => yqcoeff

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_apxshmodule_getdims_yqcoeff
      subroutine f2py_apxshmodule_getdims_zqcoeff(r,s,f2pysetdata,flag)
      use apxshmodule, only: d => zqcoeff

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_apxshmodule_getdims_zqcoeff
      subroutine f2py_apxshmodule_getdims_dxqdrhocoeff(r,s,f2pysetdata,f&
     &lag)
      use apxshmodule, only: d => dxqdrhocoeff

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_apxshmodule_getdims_dxqdrhocoeff
      subroutine f2py_apxshmodule_getdims_dyqdrhocoeff(r,s,f2pysetdata,f&
     &lag)
      use apxshmodule, only: d => dyqdrhocoeff

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_apxshmodule_getdims_dyqdrhocoeff
      subroutine f2py_apxshmodule_getdims_dzqdrhocoeff(r,s,f2pysetdata,f&
     &lag)
      use apxshmodule, only: d => dzqdrhocoeff

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_apxshmodule_getdims_dzqdrhocoeff
      subroutine f2py_apxshmodule_getdims_xgcoeff(r,s,f2pysetdata,flag)
      use apxshmodule, only: d => xgcoeff

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_apxshmodule_getdims_xgcoeff
      subroutine f2py_apxshmodule_getdims_ygcoeff(r,s,f2pysetdata,flag)
      use apxshmodule, only: d => ygcoeff

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_apxshmodule_getdims_ygcoeff
      subroutine f2py_apxshmodule_getdims_zgcoeff(r,s,f2pysetdata,flag)
      use apxshmodule, only: d => zgcoeff

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_apxshmodule_getdims_zgcoeff
      subroutine f2py_apxshmodule_getdims_sh(r,s,f2pysetdata,flag)
      use apxshmodule, only: d => sh

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_apxshmodule_getdims_sh
      subroutine f2py_apxshmodule_getdims_shgradtheta(r,s,f2pysetdata,fl&
     &ag)
      use apxshmodule, only: d => shgradtheta

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_apxshmodule_getdims_shgradtheta
      subroutine f2py_apxshmodule_getdims_shgradphi(r,s,f2pysetdata,flag&
     &)
      use apxshmodule, only: d => shgradphi

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_apxshmodule_getdims_shgradphi
      subroutine f2py_apxshmodule_getdims_polynomq(r,s,f2pysetdata,flag)
      use apxshmodule, only: d => polynomq

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_apxshmodule_getdims_polynomq
      subroutine f2py_apxshmodule_getdims_dpolynomq(r,s,f2pysetdata,flag&
     &)
      use apxshmodule, only: d => dpolynomq

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_apxshmodule_getdims_dpolynomq
      subroutine f2py_apxshmodule_getdims_polynomg(r,s,f2pysetdata,flag)
      use apxshmodule, only: d => polynomg

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_apxshmodule_getdims_polynomg
      subroutine f2py_apxshmodule_getdims_pbar(r,s,f2pysetdata,flag)
      use apxshmodule, only: d => pbar

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_apxshmodule_getdims_pbar
      subroutine f2py_apxshmodule_getdims_vbar(r,s,f2pysetdata,flag)
      use apxshmodule, only: d => vbar

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_apxshmodule_getdims_vbar
      subroutine f2py_apxshmodule_getdims_wbar(r,s,f2pysetdata,flag)
      use apxshmodule, only: d => wbar

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_apxshmodule_getdims_wbar
      subroutine f2py_apxshmodule_getdims_epochgrid(r,s,f2pysetdata,flag&
     &)
      use apxshmodule, only: d => epochgrid

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_apxshmodule_getdims_epochgrid
      
      subroutine f2pyinitapxshmodule(f2pysetupfunc)
      use apxshmodule, only : nterm
      use apxshmodule, only : nmax
      use apxshmodule, only : mmax
      use apxshmodule, only : lmax
      use apxshmodule, only : nepoch
      use apxshmodule, only : ntermsh
      use apxshmodule, only : vecflag
      use apxshmodule, only : coeff0
      use apxshmodule, only : qcoeff0
      use apxshmodule, only : gcoeff0
      use apxshmodule, only : xqcoeff
      use apxshmodule, only : yqcoeff
      use apxshmodule, only : zqcoeff
      use apxshmodule, only : dxqdrhocoeff
      use apxshmodule, only : dyqdrhocoeff
      use apxshmodule, only : dzqdrhocoeff
      use apxshmodule, only : xgcoeff
      use apxshmodule, only : ygcoeff
      use apxshmodule, only : zgcoeff
      use apxshmodule, only : sh
      use apxshmodule, only : shgradtheta
      use apxshmodule, only : shgradphi
      use apxshmodule, only : polynomq
      use apxshmodule, only : dpolynomq
      use apxshmodule, only : polynomg
      use apxshmodule, only : pbar
      use apxshmodule, only : vbar
      use apxshmodule, only : wbar
      use apxshmodule, only : epochgrid
      use apxshmodule, only : h
      use apxshmodule, only : reph
      use apxshmodule, only : rho
      use apxshmodule, only : xq
      use apxshmodule, only : yq
      use apxshmodule, only : zq
      use apxshmodule, only : qlat
      use apxshmodule, only : qlon
      use apxshmodule, only : sinqlat
      use apxshmodule, only : cosqlat
      use apxshmodule, only : cosqlon
      use apxshmodule, only : sinqlon
      use apxshmodule, only : xqgrad
      use apxshmodule, only : yqgrad
      use apxshmodule, only : zqgrad
      use apxshmodule, only : qlatgrad
      use apxshmodule, only : qlongrad
      use apxshmodule, only : pi
      use apxshmodule, only : dtor
      use apxshmodule, only : pid2
      use apxshmodule, only : twopi
      use apxshmodule, only : req
      use apxshmodule, only : eps
      use apxshmodule, only : re
      use apxshmodule, only : ecc2
      use apxshmodule, only : missing
      use apxshmodule, only : datafile
      use apxshmodule, only : epoch
      use apxshmodule, only : altlastq
      use apxshmodule, only : altlastg
      use apxshmodule, only : loadflag
      external f2pysetupfunc
      external f2py_apxshmodule_getdims_coeff0
      external f2py_apxshmodule_getdims_qcoeff0
      external f2py_apxshmodule_getdims_gcoeff0
      external f2py_apxshmodule_getdims_xqcoeff
      external f2py_apxshmodule_getdims_yqcoeff
      external f2py_apxshmodule_getdims_zqcoeff
      external f2py_apxshmodule_getdims_dxqdrhocoeff
      external f2py_apxshmodule_getdims_dyqdrhocoeff
      external f2py_apxshmodule_getdims_dzqdrhocoeff
      external f2py_apxshmodule_getdims_xgcoeff
      external f2py_apxshmodule_getdims_ygcoeff
      external f2py_apxshmodule_getdims_zgcoeff
      external f2py_apxshmodule_getdims_sh
      external f2py_apxshmodule_getdims_shgradtheta
      external f2py_apxshmodule_getdims_shgradphi
      external f2py_apxshmodule_getdims_polynomq
      external f2py_apxshmodule_getdims_dpolynomq
      external f2py_apxshmodule_getdims_polynomg
      external f2py_apxshmodule_getdims_pbar
      external f2py_apxshmodule_getdims_vbar
      external f2py_apxshmodule_getdims_wbar
      external f2py_apxshmodule_getdims_epochgrid
      call f2pysetupfunc(nterm,nmax,mmax,lmax,nepoch,ntermsh,vecflag,f2p&
     &y_apxshmodule_getdims_coeff0,f2py_apxshmodule_getdims_qcoeff0,f2py&
     &_apxshmodule_getdims_gcoeff0,f2py_apxshmodule_getdims_xqcoeff,f2py&
     &_apxshmodule_getdims_yqcoeff,f2py_apxshmodule_getdims_zqcoeff,f2py&
     &_apxshmodule_getdims_dxqdrhocoeff,f2py_apxshmodule_getdims_dyqdrho&
     &coeff,f2py_apxshmodule_getdims_dzqdrhocoeff,f2py_apxshmodule_getdi&
     &ms_xgcoeff,f2py_apxshmodule_getdims_ygcoeff,f2py_apxshmodule_getdi&
     &ms_zgcoeff,f2py_apxshmodule_getdims_sh,f2py_apxshmodule_getdims_sh&
     &gradtheta,f2py_apxshmodule_getdims_shgradphi,f2py_apxshmodule_getd&
     &ims_polynomq,f2py_apxshmodule_getdims_dpolynomq,f2py_apxshmodule_g&
     &etdims_polynomg,f2py_apxshmodule_getdims_pbar,f2py_apxshmodule_get&
     &dims_vbar,f2py_apxshmodule_getdims_wbar,f2py_apxshmodule_getdims_e&
     &pochgrid,h,reph,rho,xq,yq,zq,qlat,qlon,sinqlat,cosqlat,cosqlon,sin&
     &qlon,xqgrad,yqgrad,zqgrad,qlatgrad,qlongrad,pi,dtor,pid2,twopi,req&
     &,eps,re,ecc2,missing,datafile,epoch,altlastq,altlastg,loadflag)
      end subroutine f2pyinitapxshmodule

      subroutine f2py_alfbasismodule_getdims_anm(r,s,f2pysetdata,flag)
      use alfbasismodule, only: d => anm

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_alfbasismodule_getdims_anm
      subroutine f2py_alfbasismodule_getdims_cm(r,s,f2pysetdata,flag)
      use alfbasismodule, only: d => cm

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_alfbasismodule_getdims_cm
      subroutine f2py_alfbasismodule_getdims_bnm(r,s,f2pysetdata,flag)
      use alfbasismodule, only: d => bnm

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_alfbasismodule_getdims_bnm
      subroutine f2py_alfbasismodule_getdims_dnm(r,s,f2pysetdata,flag)
      use alfbasismodule, only: d => dnm

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_alfbasismodule_getdims_dnm
      subroutine f2py_alfbasismodule_getdims_en(r,s,f2pysetdata,flag)
      use alfbasismodule, only: d => en

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_alfbasismodule_getdims_en
      subroutine f2py_alfbasismodule_getdims_marr(r,s,f2pysetdata,flag)
      use alfbasismodule, only: d => marr

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_alfbasismodule_getdims_marr
      subroutine f2py_alfbasismodule_getdims_narr(r,s,f2pysetdata,flag)
      use alfbasismodule, only: d => narr

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_alfbasismodule_getdims_narr
      
      subroutine f2pyinitalfbasismodule(f2pysetupfunc)
      use alfbasismodule, only : nmax0
      use alfbasismodule, only : mmax0
      use alfbasismodule, only : anm
      use alfbasismodule, only : cm
      use alfbasismodule, only : bnm
      use alfbasismodule, only : dnm
      use alfbasismodule, only : en
      use alfbasismodule, only : marr
      use alfbasismodule, only : narr
      external f2pysetupfunc
      external f2py_alfbasismodule_getdims_anm
      external f2py_alfbasismodule_getdims_cm
      external f2py_alfbasismodule_getdims_bnm
      external f2py_alfbasismodule_getdims_dnm
      external f2py_alfbasismodule_getdims_en
      external f2py_alfbasismodule_getdims_marr
      external f2py_alfbasismodule_getdims_narr
      call f2pysetupfunc(nmax0,mmax0,f2py_alfbasismodule_getdims_anm,f2p&
     &y_alfbasismodule_getdims_cm,f2py_alfbasismodule_getdims_bnm,f2py_a&
     &lfbasismodule_getdims_dnm,f2py_alfbasismodule_getdims_en,f2py_alfb&
     &asismodule_getdims_marr,f2py_alfbasismodule_getdims_narr)
      end subroutine f2pyinitalfbasismodule

! apex.f90

module apexmodule

  use coeffmodule

  implicit none

contains

  real(8) function fint(x1, x2, x3, y1, y2, y3, xfit)

    ! Second degree interpolation used by FNDAPX
    ! INPUTS:
    ! x1   = point 1 ordinate value
    ! x2   = point 2 ordinate value
    ! x3   = point 3 ordinate value
    ! y1   = point 1 abscissa value
    ! y2   = point 2 abscissa value
    ! y3   = point 3 abscissa value
    ! xfit = ordinate value to fit
    ! RETURNS:
    ! yfit = abscissa value corresponding to xfit
    !
    ! MODIFICATIONS:
    ! Apr 2004: Change from subroutine to function, rename variables and
    ! add intermediates which are otherwise calculated twice


    real(8), intent(in)  :: x1, x2, x3, y1, y2, y3, xfit
    real(8)              :: x12, x13, x23, xf1, xf2, xf3

    x12 = x1 - x2
    x13 = x1 - x3
    x23 = x2 - x3
    xf1 = xfit - x1
    xf2 = xfit - x2
    xf3 = xfit - x3

    fint = (y1 * x23 * xf2 * xf3 - y2 * x13 * xf1 * xf3 + y3 * x12 * xf1 * xf2) / (x12 * x13 * x23)
  end function fint

end module apexmodule

! These modules replaced a series of COMMON blocks in the original code
module dipole
  implicit none
  real(8)                  :: colat, elon, vp, ctp, stp
end module dipole

module fldcomd
  implicit none
  real(8)                  :: bx, by, bz, bb
end module fldcomd

module apxin
  implicit none
  real(8)                  :: yapx(3, 3)
end module apxin

module itra
  implicit none
  integer(4)               :: nstp
  real(8)                  :: sgn, ds
  real(8)                  :: y(3), yold(3), yp(3, 4)
end module itra



subroutine apex(date, igrffilein, dlat, dlon, alt, a, alat, alon, bmag, xmag, ymag, zmag, v)

  ! Calculate apex radius, latitude, longitude; and magnetic field and
  ! scalar magnetic potential.
  !
  ! INPUTS:
  ! date = Year and fraction (1990.0 = 1990 January 1, 0 UT)
  ! igrffilein = Filename for IGRF coefficient files
  ! dlat = Geodetic latitude in degrees
  ! dlon = Geodetic longitude in degrees
  ! alt = Altitude in km
  !
  ! RETURNS:
  ! a    = (Apex height + REQ)/REQ, where REQ = equatorial Earth radius.
  ! A is analogous to the L value in invariant coordinates.
  ! alat = Apex latitude in degrees (negative in S. magnetic hemisphere)
  ! alon = Apex longitude (geomagnetic longitude of apex) in degrees
  ! bmag = geomagnetic field magnitude (nT)
  ! xmag = geomagnetic field component (nT): north
  ! ymag = geomagnetic field component (nT): east
  ! zmag = geomagnetic field component (nT): downward
  ! v    = geomagnetic potential (T-m)
  !
  ! IMPORTS:
  ! dipole
  ! apexmodule
  !
  ! dipole has IGRF variables obtained from routines in magfld.f90:
  ! colat = Geocentric colatitude of geomagnetic dipole north pole (deg)
  ! elon  = East longitude of geomagnetic dipole north pole (deg)
  ! vp    = Magnitude (T-m) of dipole component of magnetic potential at
  ! geomagnetic pole and geocentric radius of 6371.0088 km
  ! ctp   = cosine of colat
  ! stp   = sine   of colat
  !
  ! ------------------------------------------------------------------------------
  ! HISTORY:
  ! Aug 1994: First version completed on the 22nd by A.D. Richmond.
  ! May 1999: Revise DS calculation in LINAPX to avoid divide by zero.
  ! Apr 2004: - Change definition of earth's equatorial radius (REQ)
  ! from the IAU-1966 spheroid (6378.160 km) to the WGS-1984
  ! spheroid (6378.137 km); see description below.
  ! - Revise comments toward a consistent format so they are
  ! easy to read.
  ! - Replace computed GO TO in ITRACE with IF blocks.
  ! - Refine FNDAPX to insure |Bdown/Btot| < 1.E-6 at apex
  ! Nov 2009: Change definition of earth's mean radius (RE) from 6371.2
  ! to the WGS84 value (6371.0088), by J.T. Emmert, NRL
  ! Feb 2021: Modified by Ashton Reimer to pass IGRF coefficients file
  ! to the COFRM subroutine call.
  ! Jul 2022: Revised to fortran 90 standards by L. Lamarche, SRI International.
  !
  ! ------------------------------------------------------------------------------
  ! Reference Spheroid Change                March 2004
  !
  ! Apex geomagnetic coordinates are based on the International Reference
  ! Geomagnetic Field (IGRF) which involves the earth's shape when converting
  ! geographic latitude and altitude to geocentric coordinates.  For this
  ! purpose, the earth is assumed to be an ellipsoid which is fatter at the
  ! equator than the poles.  The World Geodetic System 1984 spheroid
  ! (WGS-1984) is recommended in the recent release of IGRF-9 because it is
  ! used to position current satellite magnetic data (EOS Volume 84 Number 46
  ! November 18 2003).  This differs from previous IGRF releases which favored
  ! the International Astronomical Union 1966 spheroid (IAU-1966) so the Apex
  ! program conversion from geographic to geocentric coordinates in subroutine
  ! CONVRT of file magfld.f has been revised from the IAU-1966 spheroid to the
  ! WGS-1984 spheroid.
  !
  ! The spheroid used to prepare earlier IGRF releases is not always known but
  ! changing spheroids now produces differences at the earth's surface less
  ! than 1 nT, significantly less than other error sources: viz., 9 nT RMS
  ! error for older measurements reporting 1 nT accuracy, 200 nT in the
  ! vicinity of magnetized rocks, or as much as 1000 nT during and after a
  ! geomagnetic storm (www.ngdc.noaa.gov/IAGA/vmod/index.html).
  !
  ! The elliptical shape is characterized in subroutine CONVRT by eccentricity
  ! (e) which is related to the the earth's equatorial radius (a) and polar
  ! radius (b) by
  !
  ! e**2  = 1 - (b/a)**2     (1)
  !
  ! This term is part of an eighth order Lagrange expansion formula (Astron.
  ! J.  Vol. 66, p. 15-16, 1961) designed to give eight digit conversion
  ! accuracy.  The following table summarizes the relevant spheroids:
  !
  ! a           b           e**2          Source
  ! ----------- -----------  -----------  --------------
  ! -           -        0.006722670  Astron J. 1961
  ! 6378.160 km 6356.775 km  0.006701642  IAU-1966
  ! 6378.137 km 6356.752 km  0.006694478  WGS-1984
  !
  ! The previous formulation in CONVRT used the oblateness factor (epsilon),
  ! a surrogate for eccentricity, where
  !
  ! e**2 = 2*epsilon - epsilon**2
  !
  ! with oblateness revised from the 1961 paper's suggested 1/297 to 1/298.25
  ! in accordance with the IAU-1966 spheroid.  Now CONVRT is reformulated to
  ! use equation 1 with the WGS-1984 spheroid's major axis (a) and minor axis
  ! (b) for which epsilon is approximately 1/298.2528.
  !
  ! In addition to earth's equatorial radius and polar radius, the reference
  ! radius (Re) of 6371.2 km is explicit in the IGRF formula for magnetic
  ! potential and implicit in the derived magnetic field coefficients.  The
  ! reference radius has not changed in IGRF releases.
  !
  ! UPDATE - September 2022 (L. Lamarche)
  ! Considering the new epsilon value of 1/298.257223563, the two eccentricity
  ! equations discussed above are now identical down to 6 significant figures,
  ! which is more precise than the coefficient calcualtions.  Consequently,
  ! the following formulation will be used for all ecentricity calculations
  ! throughout this code:
  !
  ! e**2 = epsilon*(2 - epsilon)
  !
  ! This and other constants are defined in coeffmodule contained in magfld.f90,
  ! to be used throughout the code.
  !
  ! ------------------------------------------------------------------------------

  use dipole
  use apexmodule

  implicit none


  real(8), intent(in)               :: date
  character(len=1000), intent(in)   :: igrffilein
  real(8), intent(in)               :: dlat, dlon, alt
  real(8), intent(out)              :: a, alat, alon, bmag, xmag, ymag, zmag, v
  real(8)                           :: bx, by, bz, x, y, z
  real(8)                           :: clatp, polon, vpol

  call cofrm(date, igrffilein)
  call dypol(clatp, polon, vpol)
  colat = clatp
  ctp = cos(clatp * dtor)
  stp = sqrt(1 - CTP * CTP)
  elon = polon
  vp = vpol
  call linapx(dlat, dlon, alt, a, alat, alon, xmag, ymag, zmag, bmag)
  xmag = xmag * 1.e5
  ymag = ymag * 1.e5
  zmag = zmag * 1.e5
  bmag = bmag * 1.e5
  call gd2cart(dlat, dlon, alt, x, y, z)
  call feldg(3, x / Re, y / Re, z / Re, bx, by, bz, v)
  return
end subroutine apex


subroutine linapx(gdlat, glon, alt, a, alat, alon, xmag, ymag, zmag, f)

! Transform geographic coordinates to Apex coordinates.
!
! INPUTS:
! gdlat = Latitude  (degrees, positive northward)
! glon  = Longitude (degrees, positive eastward)
! alt   = Height of starting point (km above mean sea level)
!
! OUTPUTS:
! a     = (Apex height + REQ)/REQ, where REQ = equatorial Earth radius.
! A is analogous to the L value in invariant coordinates.
! alat  = Apex Lat. (deg)
! alon  = Apex Lon. (deg)
! xmag  = Geomagnetic field component (gauss): north
! ymag  = Geomagnetic field component (gauss): east
! zmag  = Geomagnetic field component (gauss): down
! f     = Geomagnetic field magnitude (gauss)
!
! Trace the geomagnetic field line from the given location to find the
! apex of the field line.  Before starting iterations to trace along
! the field line: (1) Establish a step size (DS, arc length in km)
! based on the geomagnetic dipole latitude; (2) determine the step
! direction from the sign of the vertical component of the geomagnetic
! field; and (3) convert to geocentric cartesian coordinates.  Each
! iteration increments a step count (NSTP) and calls ITRACE to move
! along the the field line until reaching the iteration count limit
! (MAXS) or passing the apex (IAPX=2) and then calling FNDAPX to
! determine the apex location from the last three step locations
! (YAPX); however, if reaching the iteration limit, apex coordinates
! are calculated by DIPAPX which assumes a simplified dipole field.
!
! IMPORTS:
! apxin
! dipole
! fldcomd
! itra
!
! apxin has step locations determined in itrace:
! yapx  = Matrix of cartesian coordinates (loaded columnwise) of the
! three points about the apex.  Set in subroutine itrace.
!
! dipole has IGRF variables obtained from routines in magfld.f:
! colat = Geocentric colatitude of geomagnetic dipole north pole (deg)
! elon  = East longitude of geomagnetic dipole north pole (deg)
! vp    = Magnitude (T-m) of dipole component of magnetic potential at
! geomagnetic pole and geocentric radius of 6371.0088 km
! ctp   = cosine of colat
! stp   = sine   of colat
!
! fldcomd has geomagnetic field at current trace point:
! bx    = X component (Gauss)
! by    = Y component (Gauss)
! bz    = Z component (Gauss)
! bb    = Magnitude   (Gauss)
!
! itra has field line tracing variables determined in linapx:
! nstp  = Step count.
! y     = Array containing current tracing point cartesian coordinates.
! yold  = Array containing previous tracing point cartesian coordinates.
! sgn   = Determines direction of trace.
! ds    = Step size (arc length in km).
!
! REFERENCES:
! Stassinopoulos E. G. , Mead Gilbert D., X-841-72-17 (1971) GSFC,
! Greenbelt, Maryland
!
! EXTERNALS:
! gd2cart = Convert geodetic to geocentric cartesian coordinates (in magfld.f90)
! convrt  = Convert geodetic to geocentric cylindrical or geocentric spherical
! and back (in magfld.f90).
! feldg   = Obtain IGRF magnetic field components (in magfld.f90).
! itrace  = Follow a geomagnetic field line
! dipapx  = Compute apex coordinates assuming a geomagnetic dipole field
! fndapx  = Compute apex coordinates from the last three traced field line points
!
! ------------------------------------------------------------------------------
! HISTORY:
! Oct 1973: Initial version completed on the 29th by Wally Clark, NOAA
! ERL Lab.
! Feb 1988: Revised on the 1st by Harsh Anand Passi, NCAR.
! Aug 1994: Revision by A. D. Richmond, NCAR.
! Nov 2009: Change definition of earth's mean radius (RE) from 6371.2
! to the WGS84 value (6371.0088), by J.T. Emmert, NRL.
! Jul 2022: Revised to fortran 90 standards by L. Lamarche, SRI International.



  use fldcomd
  use apxin
  use dipole
  use itra
  use apexmodule

  implicit none

  real(8), intent(in)   :: gdlat, glon, alt
  real(8), intent(out)  :: a, alat, alon, xmag, ymag, zmag, f
  real(8)               :: bnrth, beast, bdown, babs
  real(8)               :: cgml2, gclat, ht, r, rho
  real(8)               :: singml, xlat, xlon
  integer(4)            :: i, j, iapx
  integer(4), parameter :: maxs = 200

  ! Set step size based on the goemagnetic dipole latitude of the starting point
  call convrt(2, gdlat, alt, gclat, r)
  singml = ctp * sin(gclat * dtor) + stp * cos(gclat * dtor) * cos((glon - elon) * dtor)
  ! May 1999: avoid possible divide by zero (when SINGML = 1.): the old version
  ! limited DS to its value at 60 deg GM latitude with:
  ! DS = .06*R/(1.-SINGML*SINGML) - 370. IF (DS .GT. 1186.) DS = 1186.
  cgml2 = amax1(0.25, 1.- singml * singml)
  ds = 0.06 * r / cgml2 - 370.

  ! Initialize yapx array
  do j = 1, 3
    do i = 1, 3
      yapx(i, j) = 0.
    end do
  end do

  ! Convert from geodetic to earth centered cartesian coordinates
  call gd2cart(gdlat, glon, alt, y(1), y(2), y(3))
  nstp = 0

  ! Get magnetic field components to determine the direction for tracing the field line
  call feldg(1, gdlat, glon, alt, xmag, ymag, zmag, f)
  sgn = sign(1.D0, - zmag)

  ! Use cartesian coordinates to get magnetic field components (from which gradients steer the tracing)
  iapx = 1
  do while (iapx .EQ. 1)
    call feldg(2, y(1) / Re, y(2) / Re, y(3) / Re, bx, by, bz, bb)
    nstp = nstp + 1
    if (nstp .ge. maxs) exit
    call itrace(iapx)
  end do
  if (nstp < maxs) then
    call fndapx(alt, zmag, a, alat, alon)
  else
    rho = sqrt(y(1) ** 2 + y(2) ** 2)
    call convrt(3, xlat, ht, rho, y(3))
    xlon = rtod * atan2(y(2), y(1))
    call feldg(1, xlat, xlon, ht, bnrth, beast, bdown, babs)
    call dipapx(xlat, xlon, ht, bnrth, beast, bdown, a, alon)
    alat = - sgn * rtod * acos(sqrt(1./ a))
  end if

  return

end subroutine linapx


subroutine itrace(iapx)

! Follow a geomagnetic field line until passing its apex
!
! INPUTS:
! (all are in imported modules)
! OUTPUTS:
! iapx = 2 (when apex passed) or 1 (not)
!
! This uses the 4-point Adams formula after initialization.
! First 7 iterations advance point by 3 steps.
!
! IMPORTS:
! apxin
! fldcomd
! itra
!
! apxin has step locations determined in itrace:
! yapx  = Matrix of cartesian coordinates (loaded columnwise) of the
! three points about the apex.  Set in subroutine itrace.
!
! fldcomd has geomagnetic field at current trace point:
! bx    = X component (Gauss)
! by    = Y component (Gauss)
! bz    = Z component (Gauss)
! bb    = Magnitude   (Gauss)
!
! itra has field line tracing variables determined in linapx:
! nstp  = Step count.
! y     = Array containing current tracing point cartesian coordinates.
! yold  = Array containing previous tracing point cartesian coordinates.
! sgn   = Determines direction of trace.
! ds    = Step size (arc length in km).
!
! REFERENCES:
! Stassinopoulos E. G. , Mead Gilbert D., X-841-72-17 (1971) GSFC,
! Greenbelt, Maryland
! ------------------------------------------------------------------------------
! HISTORY:
! Oct 1973: Initial version completed on the 29th by W. Clark, NOAA ERL
! Laboratory.
! Feb 1988: Revised by H. Passi, NCAR.
! Apr 2004: Replace computed GO TO with IF blocks because some compilers
! are threatening to remove this old feature
! Jul 2022: Revised to fortran 90 standards by L. Lamarche, SRI International.



  use apxin
  use fldcomd
  use itra

  implicit none

  integer(4), intent(out)  :: iapx
  real(8)                  :: d12, d2, d24, d6, rc, rp
  integer(4)               :: i, j


  iapx = 1

  ! Cartesian component magnetic field (partial) derivitives steer the trace
  yp(1, 4) = sgn * bx / bb
  yp(2, 4) = sgn * by / bb
  yp(3, 4) = sgn * bz / Bb

  d2 = ds / 2.
  d6 = ds / 6.
  d12 = ds / 12.
  d24 = ds / 24.

  if (nstp .le. 7) then
    do i = 1, 3
      if (nstp == 1) then
        yp(i, 1) = yp(i, 4)
        yold(i) = y(i)
        yapx(i, 1) = y(i)
        y(i) = yold(i) + ds * yp(i, 1)

      else if (nstp == 2) then
        yp(i, 2) = yp(i, 4)
        y(i) = yold(i) + d2 * (yp(i, 2) + yp(i, 1))

      else if (nstp == 3) then
        y(i) = yold(i) + d6 * (2.* yp(i, 4) + yp(i, 2) + 3.* yp(i, 1))

      else if (nstp == 4) then
        yp(i, 2) = yp(i, 4)
        yapx(i, 2) = y(i)
        yold(i) = y(i)
        y(i) = yold(i) + d2 * (3.* yp(i, 2) - yp(i, 1))

      else if (nstp == 5) then
        y(i) = yold(i) + d12 * (5.* yp(i, 4) + 8.* yp(i, 2) - yp(i, 1))

      else if (nstp == 6) then
        yp(i, 3) = yp(i, 4)
        yold(i) = y(i)
        yapx(i, 3) = y(i)
        y(i) = yold(i) + d12 * (23.* yp(i, 3) - 16.* yp(i, 2) + 5.* yp(i, 1))

      else if (nstp == 7) then
        yapx(i, 1) = yapx(i, 2)
        yapx(i, 2) = yapx(i, 3)
        y(i) = yold(i) + d24 * (9.* yp(i, 4) + 19.* yp(i, 3) - 5.* yp(i, 2) + yp(i, 1))
        yapx(i, 3) = y(i)

      end if
    end do

    if (nstp == 6 .or. nstp == 7) then
      rc = sqrt(yapx(1, 3) ** 2 + yapx(2, 3) ** 2 + yapx(3, 3) ** 2)
      rp = sqrt(yapx(1, 2) ** 2 + yapx(2, 2) ** 2 + yapx(3, 2) ** 2)
      if (rc < rp) iapx = 2
    end if

  else
    do i = 1, 3
      yapx(i, 1) = yapx(i, 2)
      yapx(i, 2) = y(i)
      yold(i) = y(i)
      y(i) = yold(i) + d24 * (55.* yp(i, 4) - 59.* yp(i, 3) + 37.* yp(i, 2) - 9.* yp(i, 1))
      yapx(i, 3) = y(i)
      do j = 1, 3
        yp(i, j) = yp(i, j + 1)
      end do
    end do
    rc = sqrt(y(1) ** 2 + y(2) ** 2 + y(3) ** 2)
    rp = sqrt(yold(1) ** 2 + yold(2) ** 2 + yold(3) ** 2)
    if (rc < rp) iapx = 2

  end if

  return
end subroutine itrace


subroutine fndapx(alt, zmag, a, alat, alon)

! Find apex coordinates once tracing (in subroutine ITRACE) has
! signalled that the apex has been passed.
! INPUTS:
! alt  = Altitude of starting point
! zmag = Downward component of geomagnetic field at starting point
! OUTPUT
! a    = Apex radius, defined as (Apex height + Req)/Req, where
! Req = equatorial Earth radius.
! A is analogous to the L value in invariant coordinates.
! alat = Apex Lat. (deg)
! alon = Apex Lon. (deg)
!
! IMPORTS:
! apxin
! dipole
!
! apxin has step locations determined in itrace:
! yapx  = Matrix of cartesian coordinates (loaded columnwise) of the
! three points about the apex.  Set in subroutine itrace.
!
! dipole has IGRF variables obtained from routines in magfld.f90:
! colat = Geocentric colatitude of geomagnetic dipole north pole (deg)
! elon  = East longitude of geomagnetic dipole north pole (deg)
! vp    = Magnitude (T-m) of dipole component of magnetic potential at
! geomagnetic pole and geocentric radius of 6371.0088 km
! ctp   = cosine of colat
! stp   = sine   of colat
!
! EXTERNALS:
! fint = Second degree interpolation routine
! ------------------------------------------------------------------------------
! HISTORY:
! Oct 1973: Initial version completed on the 23rd by Clark, W., NOAA
! Boulder.
! Aug 1994: Revision on the 3rd by A.D. Richmond, NCAR
! Apr 2004: Repair problem noted by Dan Weimer where the apex location
! produced by FINT may still have a non-zero vertical magnetic
! field component.
! Jul 2022: Revised to fortran 90 standards by L. Lamarche, SRI International.


  use apxin
  use dipole
  use apexmodule

  implicit none

  real(8), intent(in)   :: alt, zmag
  real(8), intent(out)  :: a, alat, alon
  real(8)               :: abdob, ang, ba, bda, bea, bna, hta, rho
  real(8)               :: r, rasq, sang, cang, ste, cte, stfcpa, stfspa, xlon
  real(8)               :: gdlt, gdln, ht, bn, be, bmag
  integer(4)            :: i, nitr
  real(8)               :: bd(3), y(3)

  ! Get geodetic height and vertical (downward) compontent of the magnetic field at least three points found by ITRACE
  do i = 1, 3
    rho = sqrt(yapx(1, i) ** 2 + yapx(2, i) ** 2)
    call convrt(3, gdlt, ht, rho, yapx(3, i))
    gdln = rtod * atan(yapx(2, i), yapx(1, i))
    call feldg(1, gdlt, gdln, ht, bn, be, bd(i), bmag)
  end do

  ! Interpolate to where Bdown=0 to find cartesian coordinates at dip equatior
  nitr = 0
  do while (nitr < 4)    ! 4 was chosen because tests rarely required 2 iterations
    y(1) = fint(bd(1), bd(2), bd(3), yapx(1, 1), yapx(1, 2), yapx(1, 3), 0.D0)
    y(2) = fint(bd(1), bd(2), bd(3), yapx(2, 1), yapx(2, 2), yapx(2, 3), 0.D0)
    y(3) = fint(bd(1), bd(2), bd(3), yapx(3, 1), yapx(3, 2), yapx(3, 3), 0.D0)

    ! Insure negligible Bdown or
    !
    ! |Bdown/Btot| < 2.E-6
    !
    ! For instance, Bdown must be less than 0.1 nT at low altitudes where
    ! Btot ~ 50000 nT.  This ratio can be exceeded when interpolation is
    ! not accurate; i.e., when the middle of the three points interpolated
    ! is too far from the dip equator.  The three points were initially
    ! defined with equal spacing by ITRACE, so replacing point 2 with the
    ! most recently fit location will reduce the interpolation span.

    rho = sqrt(y(1) ** 2 + y(2) ** 2)
    gdln = rtod * atan2(y(2), y(1))
    call convrt(3, gdlt, hta, rho, y(3))
    call feldg(1, gdlt, gdln, hta, bna, bea, bda, ba)
    abdob = abs(bda / ba)

    if (abdob > 2.e-6) then
      nitr = nitr + 1
      yapx(1, 2) = y(1)
      yapx(2, 2) = y(2)
      yapx(3, 2) = y(3)
      bd(2) = bda
    else
      exit
    end if
  end do

  if (abdob > 2.e-6) then
    write(0, '("APEX: Imprecise fit of apex: |Bdown/B| "(1PE7.1))') abdob
  end if


  ! Ensure altitude of the Apex is at least the initial altitude when
  ! defining the Apex radius then use it to define the Apex latitude whose
  ! hemisphere (sign) is inferred from the sign of the dip angle at the
  ! starting point

  a = (Req + amax1(alt, hta)) / Req
  if (a < 1.) then
    write(0, '("APEX: A cannot be less than 1; A, REQ, HTA "(1P3))') a, Req, hta
    ! write(0, *) "APEX: A cannot be less than 1; A, REQ, HTA ", a, Req, hta
    call exit(1)
  end if
  rasq = acos(sqrt(1./ a)) * rtod
  alat = sign(rasq, zmag)

  ! alon is the dipole longitude of the apex and is defined using
  ! spherical coordinates where
  ! gp   = geographic pole.
  ! gm   = geomagnetic pole (colatitude colat, east longitude elon).
  ! xlon = longitude of apex.
  ! te   = colatitude of apex.
  ! ang  = longitude angle from gm to apex.
  ! tp   = colatitude of gm.
  ! tf   = arc length between gm and apex.
  ! pa   = alon be geomagnetic longitude, i.e., pi minus angle measured
  ! counterclockwise from arc gm-apex to arc gm-gp.
  ! then, spherical-trigonometry formulas for the functions of the angles
  ! are as shown below.  Notation uses c=cos, s=sin and stfcpa = sin(tf) * cos(pa),
  ! stfspa = sin(tf) * sin(pa)

  xlon = atan2(y(2), y(1))
  ang = xlon - elon * dtor
  cang = cos(ang)
  sang = sin(ang)
  r = sqrt(y(1) ** 2 + y(2) ** 2 + y(3) ** 2)
  cte = y(3) / r
  ste = sqrt(1.- cte * cte)
  stfcpa = ste * ctp * cang - cte * stp
  stfspa = sang * ste
  alon = atan2(stfspa, stfcpa) * rtod

  return
end subroutine fndapx


subroutine dipapx(gdlat, gdlon, alt, bnorth, beast, bdown, a, alon)

! Compute a, alon from local magnetic field using dipole and spherical
! approximation.
!
! INPUTS:
! gdlat  = geodetic latitude, degrees
! gdlon  = geodetic longitude, degrees
! alt    = altitude, km
! bnorth = geodetic northward magnetic field component (any units)
! beast  = eastward magnetic field component
! bdown  = geodetic downward magnetic field component
! OUTPUTS:
! a      = apex radius, 1 + h_A/R_eq
! alon   = apex longitude, degrees
!
! Use spherical coordinates and define:
! gp    = geographic pole.
! gm    = geomagnetic pole (colatitude colat, east longitude elon).
! g     = point at gdlat,gdlon.
! e     = point on sphere below apex of dipolar field line passing
! through g.
! td    = dipole colatitude of point g, found by applying dipole
! formula for dip angle to actual dip angle.
! b     = pi plus local declination angle.  b is in the direction
! from g to e.
! tg    = colatitude of tg.
! ang   = longitude angle from gm to g.
! te    = colatitude of e.
! tp    = colatitude of gm.
! a     = longitude angle from g to e.
! apang = a + ang
! pa    = geomagnetic longitude, i.e., Pi minus angle measured
! counterclockwise from arc gm-e to arc gm-gp.
! tf    = arc length between gm and e.
! Then, using notation c=cos, s=sin, cot=cot, spherical-trigonometry
! formulas for the functions of the angles are as shown below.  Note:
! stfcpa = sin(tf) * cos(pa)
! stfcpa = sin(tf) * sin(pa)
!
! IMPORTS:
! dipole
!
! dipole has IGRF variables obtained from routines in magfld.f90:
! colat = Geocentric colatitude of geomagnetic dipole north pole (deg)
! elon  = East longitude of geomagnetic dipole north pole (deg)
! vp    = Magnitude (T-m) of dipole component of magnetic potential at
! geomagnetic pole and geocentric radius of 6371.0088 km
! ctp   = cosine of colat
! stp   = sine   of colat
! ------------------------------------------------------------------------------
! HISTORY:
! May 1994:  Completed on the 1st by A. D. Richmond
! Nov 2009: Change definition of earth's mean radius (RE) from 6371.2
! to the WGS84 value (6371.0088), by J.T. Emmert, NRL.
! Jul 2022: Revised to fortran 90 standards by L. Lamarche, SRI International.


  use dipole
  use apexmodule

  implicit none

  real(8), intent(in)   :: gdlat, gdlon, alt, bnorth, beast, bdown
  real(8), intent(out)  :: a, alon
  real(8)               :: ang, bhor, ca, cang, capang, cb, cottd, ctd, cte, ctg
  real(8)               :: ha, r, sa, sang, sb, std, ste, stfcpa, stg, sapang, stfspa


  bhor = sqrt(bnorth * bnorth + beast * beast)
  if (bhor == 0.) then
    alon = 0.
    a = 1.E34
    return
  end if

  cottd = bdown * 0.5 / bhor
  std = 1./ sqrt(1.+ cottd * cottd)
  ctd = cottd * std
  sb = - beast / bhor
  cb = - bnorth / bhor
  ctg = sin(gdlat * dtor)
  stg = cos(gdlat * dtor)
  ang = (gdlon - elon) * dtor
  sang = sin(ang)
  cang = cos(ang)
  cte = ctg * std + stg * ctd * cb
  ste = sqrt(1.- cte * cte)
  sa = sb * ctd / ste
  ca = (std * stg - ctd * ctg * cb) / ste
  capang = ca * cang - sa * sang
  sapang = ca * sang + sa * cang
  stfcpa = ste * ctp * capang - cte * stp
  stfspa = sapang * ste
  alon = atan2(stfspa, stfcpa) * rtod
  r = alt + Re
  ha = alt + r * cottd * cottd
  a = 1. + ha / Req

  return
end subroutine dipapx

---
name: Bug report
about: Create a report to help us improve
title: 'BUG: '
labels: 'bug'
assignees: ''

---

Describe the bug
================
A clear and concise description of what the bug is.

To Reproduce
------------
Steps to reproduce the behavior:
1. Go to '...'
2. Click on '....'
3. Scroll down to '....'
4. See error

Expected behavior
-----------------
A clear and concise description of what you expected to happen.

Screenshots
-----------
If applicable, add screenshots to help explain your problem.

Computer
--------
Please provide the following information:
* OS: (e.g., iOS)
* Python version: (e.g., 3.6)
* Compiler with version: (e.g., gfortran 47)
* Apexpy version/branch: (e.g., 1.1.0/main)

Additional context
------------------
Add any other context about the problem here.

Description
===========

Please include a summary of the change and which issue is fixed. Please also
include relevant motivation and context. List any dependencies that are required
for this change.  Please see ``CONTRIBUTING.rst`` for more guidelines.

Fixes # (issue)

Type of change
--------------
Please delete options that are not relevant.

* Bug fix (non-breaking change which fixes an issue)
* New feature (non-breaking change which adds functionality)
* Breaking change (fix or feature that changes existing functionality)
* This change requires a documentation update
* Release candidate

How Has This Been Tested?
-------------------------
Please describe the tests that you ran to verify your changes. Provide
instructions so we can reproduce the desired behaviour.

```
import apexpy
# Test to perform
```

### Test Configuration

* Operating system: (e.g., Hal)
* Python version number: (e.g., 3.7)
* Compiler with version number: (e.g. gfortran 9.0)
* Relevant local setup details: (e.g., apexpy version/branch)

Checklist
---------
- [ ] Make sure you are merging into the ``develop`` (not ``main``) branch
- [ ] My code follows the style guidelines of this project
- [ ] I have performed a self-review of my own code
- [ ] I have commented my code, particularly in hard-to-understand areas
- [ ] I have made corresponding changes to the documentation
- [ ] My changes generate no new warnings
- [ ] I have added tests that prove my fix is effective or that my feature works
- [ ] New and existing unit tests pass locally with my changes
- [ ] Any dependent changes have been merged and published in downstream modules
- [ ] Add a note to ``Changelog.rst``, summarising the changes
- [ ] Add yourself to ``AUTHORS.rst`` and ``.zenodo.json``

---
name: Feature request
about: Suggest an idea for this project
title: 'ENH: '
labels: 'enhancement'
assignees: ''
---

Requested feature
=================
A short description of what you are proposing.

The problem or gap this feature will address
--------------------------------------------
A clear and concise description of what the problem is. For example, I'm always
frustrated when ...

The desired solution
--------------------
A clear and concise description of what you want to happen.  Keep the scope as
narrow as possible, to make it easier to implement

Possible alternatives
---------------------
A clear and concise description of any alternative solutions or features you've
considered.

Additional context
------------------
Add any other context or screenshots about the feature request here.  For
context, the apexpy version/branch you're working on, your system detail, your
python version, and your compiler (with version) may or may not be relevant.

Reminders
---------
This is a volunteer-driven project.  Code contributions are welcome, as is help
testing new code.

---
name: Question
about: Ask a question (and help us improve our documentation)
title: 'Question: '
labels: 'question'
assignees: ''

---

Describe the problem or ask the question
========================================
A clear and concise description of what the problem or question is.

Provide an example, if applicable
---------------------------------
Steps to reproduce the behavior:
1. Go to '...'
2. Click on '....'
3. Scroll down to '....'
4. See behaviour

Expectations
------------
A clear and concise description of what you expected (or wanted) to happen.

Screenshots
-----------
If applicable, add screenshots to help explain your question.

Computer
--------
Please complete the following information:
* OS: (e.g., iOS)
* Python version: (e.g., 3.6)
* Compiler with version: (e.g., gfortran 22)
* Apexpy version/branch: (e.g., 1.1.0/main)

Additional context
------------------
Add any other context about the problem here.
